#!usr/bin/perl

#Norwegian decomposition tool

use locale;
use POSIX 'locale_h';
setlocale(LC_CTYPE,$locale{Norwegian});

##########################################################################################
#Read command line arguments
$infile = $ARGV[0];
$outfile = $ARGV[1];

open (IN, $infile) or die "Can't open $infile: $!\n";
open OUT,">$outfile";

##########################################################################################
#Set user parameters
$lg = 1;					# log-writing on/off
open LOGG, ">logg.out" if $lg;

$show_infl = 1;					# show inflectional separators in output

##########################################################################################
#Open program code and lists required for decomposition
require '\.\\subs\\main_decompose.pl';
require '\.\\subs\\nordel_vars.pl';
require '\.\\subs\\nordel_subs.pl';
require '\.\\subs\\nordel_clusters.pl';
require '\.\\subs\\nordel_filelist.pl';

##########################################################################################
#Main loop

while (<IN>) {
	chomp;
	$line = $_;
	@words = split /\s/, $line;
	foreach $word (@words) {
		print "$word\t";
		&init_vars;
		print LOGG "$wd\n" if $lg;
		next if ($word !~ /$lc/i);
		$word = &punctuation($word);
		$word = &case($word);
		$wn = &decompose($word);
		$wn = ucfirst $wn if $init_cap;
		print LOGG "Finally: $wn\n\n" if $lg;
		print LOGG "-" x 90, "\n" if $lg;
		print OUT "$wn\n";
		print "$wn\n";
	}
}

#The end
##########################################################################################
