#!usr/bin/perl

#Norwegian decomposition tool

use locale;
use POSIX 'locale_h';
setlocale(LC_CTYPE,$locale{Norwegian});

##########################################################################################
#open IN, "nor020124NST.decomp";
#open IN, "nor020124NST.decomp.rand";
#open IN, "temp.decomp";
open IN, "temp";
open OUT,">RESULT.out";

##########################################################################################
#Set user parameters
$lg = 1;					# log-writing on/off
open LOGG, ">logg.out" if $lg;

$show_infl = 0;					# show inflectional separators in output

##########################################################################################
#Open program code and lists required for decomposition
require '\.\\subs\\main_decompose.pl';
require '\.\\subs\\nordel_vars.pl';
require '\.\\subs\\nordel_subs.pl';
require '\.\\subs\\nordel_clusters.pl';
require '\.\\subs\\nordel_con_cluster_subs.pl';
require '\.\\subs\\nordel_filelist.pl';

##########################################################################################
#Main loop

$count = 0;

while (<IN>) {
	chomp;
	$count++;

#	next if ($count < 4000);  		# Delete this from actual decompounder, just for testing
#	last if ($count > 10000);  		# Delete this from actual decompounder, just for testing

	print "Processing entry $count\n" if $count =~ /00$/;
	$line = $_;
	($word, $dec) = split /\t/, $line;

#	next if ($word !~ /($con){4,4}/); 	# Delete this from actual decompounder, just for testing

	&init_vars;
	print LOGG "$word\n" if $lg;
	next if ($word !~ /$lc/i);
	$word = &punctuation($word);
	$word = &case($word);
	$wn = &decompose($word);
	$wn = ucfirst $wn if $init_cap;
	print LOGG "Finally: $wn\n\n" if $lg;
	print LOGG "-" x 90, "\n\n" if $lg;
	print "$wn\n";
	
#Comparison with "+" is tricky. So comparing on basis of other symbol. 
	$wn_1 = $wn;
	$dec_1 = $dec;
	$wn_1 =~ s/\+//g;
	$dec_1 =~ s/\+//g;

	if ($wn_1 =~ /$dec_1/) {
		print OUT "CORRECT:\t$wn\n";
		$right++;
	}
	else {
		print OUT "WRONG:\t$wn\tshould be\t$dec\n";
		print LOGG "Uh-oh!\n";
		$wrong++;
	}
}

print OUT "\n-----------------------------------\n";
print OUT "SUM CORRECT:\t$right\n";
print OUT "SUM ERRORS:\t$wrong\n";

$pct = $wrong / ($right + $wrong);
print OUT "Error rate:\t$pct\n";

#The end
##########################################################################################
