#!usr/bin/perl

#Main decomposition subroutine required for Norwegian decomposition tool

##########################################################################################
#Main decomposition subroutine

sub decompose {
	my $wd = shift;
	my $orig = $wd;
	my $dont = 0;
	
	#PROCESSING OF ENTIRE WORD
	#Decompose hypenated words
	$wd = &hyphen($wd);
	
	#Special treatment of four-five-letter words
	if ($wd =~ /^....(.)?$/) {
		$wd = &short_compound($wd);
		return $wd;	#no need to look any further
	}

	#General non-decomposition rules
	$dont = 1 if $wd !~ /...../;	#only five-letter words and longer are decomposed
	return $wd if $dont == 1; 

print LOGG "A\t$wd\n";
	$wd = &geminate_compound($wd);
	$wd = &full_compound($wd);
	$wd = &rare_link_morph($wd);

print LOGG "B\t$wd\n";

	#Decompose prefixed and suffixed words
	$wd = &pfx_sfx($wd);


#	$wd = &inflection($wd,$infl);
#	($wd,$infl) = split "~", $wd;

	#PROCESSING DECOMPOSED UNITS
	#Lookup in rmcc-list
	@dec = split /\+/, $wd;
	$nmb = scalar @dec;
	for ($n = 0; $n <= $nmb; $n++) {
#		if (($dec[$n] =~ /\w/) && ($dec[$n] !~ /($suffix)(\~(s|e))?$/)) {
		if ($dec[$n] =~ /\w/) {
			$dec[$n] = &common_rmcc($dec[$n]);
		}
	}
	$wd = join "\+", @dec;

	#Lookup in lmcc-lists
	@dec = split /\+/, $wd;
	$nmb = scalar @dec;
	for ($n = 0; $n <= $nmb; $n++) {
#		if (($dec[$n] =~ /\w/) && ($dec[$n] !~ /($suffix)(\~(s|e))?$/)) {
		if ($dec[$n] =~ /\w/) {
			$dec[$n] = &common_lmcc($dec[$n]);
		}
	}
	$wd = join "\+", @dec;

	#And finally, cluster decomposition


	# HANDLE CLUSTERS WITH TWO CONSONANTS HERE
	#Lookup in vow_con list
print LOGG "C\t$wd\n";
#	@dec = split /\+/, $wd;
#	$nmb = scalar @dec;
#	for ($n = 0; $n <= $nmb; $n++) {
#		if ($dec[$n] =~ /\w/) {
#			$dec[$n] = &vow_con($dec[$n]);
#		}
#	}
#	$wd = join "\+", @dec;
print LOGG "D\t$wd\n";

	#Lookup in con_vow list
#	@dec = split /\+/, $wd;
#	$nmb = scalar @dec;
#	for ($n = 0; $n <= $nmb; $n++) {
#		if ($dec[$n] =~ /\w/) {
#			$dec[$n] = &con_vow($dec[$n]);
#		}
#	}
#	$wd = join "\+", @dec;
print LOGG "E\t$wd\n";

	# HANDLE CLUSTERS WITH THREE OR MORE CONSONANTS HERE
	@dec = split /\+/, $wd;
	$nmb = scalar @dec;
	for ($n = 0; $n <= $nmb; $n++) {
#		if (($dec[$n] =~ /\w/) && ($dec[$n] !~ /~(s|e)$/)) {
		if ($dec[$n] =~ /\w/) {
			$dec[$n] = &cluster($dec[$n]) if $dec[$n];
		}
	}
	$wd = join "\+", @dec;
	
	$wd = &check_e_strip($wd);

	#Check two-letter items
	print LOGG "$wd before two-letter check\n" if $lg;
	@dec = split /\+/, $wd;
	$nmb = scalar @dec;
	for ($n = 0; $n <= $nmb; $n++) {
		if (($dec[$n] =~ /^..$/) && ($dec[$n] !~ /^($two_letter_roots)$/)) {
			$dec[$n] = "$dec[$n]"."";
		}
	}
	$wd = join "\+", @dec;
	$wd =~ s/\+//g;
	$wd =~ s/\+(..)/$1/g;
	$wd =~ s/~(e|s)([^nr\+])/$1$2/g;
	print LOGG "$wd after two-letter check\n" if $lg;

	$wd =~ s/\+\+(\+)?/\+/g;

	if ($show_infl) {
		$wd = $wd."~".$infl if $infl;
	}
	else {
		$wd = $wd.$infl if $infl;
	}

print LOGG "F\t$wd\n";

	@dec = split /\+/, $wd;
	$nmb = scalar @dec;
	for ($n = 0; $n <= $nmb; $n++) {
		if ($dec[$n] =~ /\w/) {
			$dec[$n] = &short_compound($dec[$n]);
			$dec[$n] = &check_s_strip($dec[$n]) if ($dec[$n] =~ /~s$/);
		}
	}
	$wd = join "\+", @dec;
	#Decompose familiar compounds

print LOGG "G\t$wd\n";

	return $wd;
} #end sub
##########################################################################################

1;
