#!usr/bin/perl

#Subs for handling of consonant clusters for Norwegian decomposition tool

##########################################################################################

sub n_cluster {
	my ($cl) = shift;
	my ($wd) = shift;
	my $orig_cl = $cl;
	my $orig_wd = $wd;

	print LOGG "Entered sub n_cluster with cluster $cl and word $wd\n" if $lg;

$n_cls_roots = 'finland|fenrik|genre|skonrok|conrad|enroll|erinr|henrik|konrad|canvas|envoy|inva|inve|
invit|involver|kanvas|konvek|konven|konver|konvoi|konvuls|konvalesen|convert|bonbon|enqu|fanfare|
genfer|genfkors|input|mignon|myanmar|quinquagesima|revansj|runway|sanforiser|sanmarin|sinfonia|unfair'; 

$nn_final = 'bann|bonn|brann|brenn|brnn|bunn|bnn|dynn|finn|funn|grunn|grnn|hann|hunn|inn|kinn|kvann|linn|lnn|
             mann|menn|munn|sann|skinn|skjnn|spenn|svinn|tann|tenn|tinn|tonn|trinn|tynn|vann';
$n_final = 'aften|agn|allmen|alpin|altan|alun|anilin|annen|appelsin|astrakan|asynkron|atropin|atten|autogen|
aversan|bacon|badminton|bakhun|banan|bardun|barn|baron|baryton|basun|baun|bein|bekken|ben|bensin|benzen|billion|
bison|bjrn|blikken|botn|brun|chiffon|demon|devon|diakon|divan|don|doven|dragon|dun|dusin|dgn|egen|eien|eigen|ekorn|
elektron|en|epigon|estragon|famn|fan|fasan|favn|femten|fersken|fiken|fin|fiolin|fjern|fjorten|foran|forn|freon|frossen|
frken|fn|gagn|gardin|garn|gen|gluten|gobelin|grammofon|gran|gravenstein|gravensten|grein|gren|gryn|grn|gyllen|halogen
|han|harpun|heiman|helgen|hevn|histamin|hormon|horn|human|hun|hydrogen|hn|hgoktan|ikorn|immun|insulin|jern|jevn|jotun
|kabin|kanon|kaptein|karabin|karbon|kardigan|karmin|kelvin|kjkken|klan|kokain|kolofon|konfesjon|korn|kran|kristen
|krokan|kvern|kvin|laken|latin|leksikon|lemen|liaison|lidokain|lin|loden|lyn|ln|lgn|lsen|magasin|maraton|marin
|marsipan|maskin|medisin|melamin|merian|mesan|mesanin|meson|million|monsun|morfin|morgen|naken|navn|neon|nesten
|nikotin|nitten|non|norrn|nylon|nytron|oksygen|oktan|oliven|olivin|organsin|osean|ozon|palmitin|parafin|parmesan
|patron|penicillin|person|pidgin|plan|plen|pollen|polyuretan|preken|propan|propion|protein|raglan|ramn|ravn|region
|regn|rein|reklamasjon|remington|ren|rogn|roman|rosen|rubin|ruin|rntgen|saffian|safran|sagn|salangan|saloon|sammen
|sein|seksten|sen|simultan|sitdown|sitron|skin|skitten|skjedehorn|sopran|spion|spon|stearin|stein|syn|synkron|syrin
|sytten|ssken|svn|tallerken|tartan|tegn|telefon|termin|terpentin|tidvatn|titan|torden|tretten|tron|tuberkulin|turbin
|turn|tusen|trn|uran|uretan|urin|velin|veteran|vin|vitamin|vogn|voksen|von|vulkan|vpen|western|xantogen|zen|rken';


$n_initial = 'nabb|nag|nagla|nagle|naglet|naken|nakke|napper|narkoman|narkose|narr|narre|nase|nasjon|nasjonal|natt|
	natur|naust|nav|navn|nebb|nebbe|nebbet|ned|nederlag|nedgang|nedleggelse|nedsettelse|nedsetting|nedslag|
	negativ|neger|nek|nekt|nektelse|nekter|nekting|nellik|nem|nemnd|nerve|nese|nesle|nett|netting|neurose|
	neve|nevner|nevnt|nevrose|nisse|nitrat|niv|nonne|nordisk|norm|normal|normering|norsk|not|nota|note|
	notere|notering|novelle|numerisk|nummer|ny|nyanse|nykke|nymfe|nyre|nytelse|nyting|nytt|nyttig|nl|nr|
	nring|nrvrelse|nrvrende|nd|ndvendig|nff|ngd|nkkel|nste|ntt|nyd|nytral';

	#Don't split if word found in root list
	return $cl if $wd =~ /^$n_cls_roots/;
	
	#Left-final nn
	if ($wd =~ /^$nn_final/) {$cl =~ s/^nn/n\+/; print LOGG "NN_FINAL\r" if $lg;}

	#Left-final n
	if ($wd =~ /^$n_final/) {$cl =~ s/^n/n\+/; print LOGG "N_FINAL\r" if $lg;}

	#Left-final n
	if ($wd =~ /$n_initial/) {$cl =~ s/^n/\+n/; print LOGG "NN_INITIAL\r" if $lg;}

	#Handle n(+)n
	if ($cl =~ /^nn$/) {
		if ($wd =~ /bunniv/) {
			$cl =~ s/nn/nn\+n/;
		}
		else {
			return $cl
			};
	}

	print LOGG "Cluster $cl before return from sub n_cluster\n" if $lg;
	return $cl;
} #end sub

##########################################################################################

sub p {
	my $cl = shift;
	my $orig = $cl;

	print LOGG "Entered sub p with cluster $wd\n" if $lg;


	print LOGG "Cluster $cl before return from sub p\n" if $lg;
	return $cl;
} #end sub

1;
