#!usr/bin/perl

#Word lists required for Norwegian decomposition tool

##########################################################################################

open CM_LMCC, '.\libs\common_left.nd';
open CM_RMCC, '.\libs\common_right.nd';
open NOT, '.\libs\not_compound.nd';
open FULL, '.\libs\full_compound.nd';
open SHORT, '.\libs\short_compound.nd';
open E_STRIP, '.\libs\e_strip.nd';
open EN_CMP, '.\libs\en_compound.nd';
open ER_CMP, '.\libs\er_compound.nd';
open A_CMP, '.\libs\a_compound.nd';
open GEM_CMP, '.\libs\geminate_compound.nd';

open WHERE_7, '.\libs\where_to_split_7.nd';
open WHERE_6, '.\libs\where_to_split_6.nd';
open WHERE_5, '.\libs\where_to_split_5.nd';
open WHERE_4, '.\libs\where_to_split_4.nd';
open WHERE_3, '.\libs\where_to_split_3.nd';

open VC, '.\libs\ends_in_vow_con.nd';
open CV, '.\libs\begs_with_con_vow.nd';

##########################################################################################

while (<CM_LMCC>) {
	chomp;
	$cm_lmcc{$_}++;
}

while (<CM_RMCC>) {
	chomp;
	$cm_rmcc{$_}++;
}

while (<NOT>) {
	chomp;
	$not_cmp{$_}++;
}

while (<FULL>) {
	chomp;
	$full_cmp{$_}++;
}

while (<SHORT>) {
	chomp;
	$short_cmp{$_}++;
}

while (<E_STRIP>) {
	chomp;
	$e_strip{$_}++;
}

while (<EN_CMP>) {
	chomp;
	$en_cmp{$_}++;
}

while (<ER_CMP>) {
	chomp;
	$er_cmp{$_}++;
}

while (<A_CMP>) {
	chomp;
	$a_cmp{$_}++;
}

while (<GEM_CMP>) {
	chomp;
	($nodec, $dec) = split /\t/; 
	$gem_cmp{$nodec} = $dec;
}

while (<WHERE_7>) {
	chomp;
	($nodec, $dec) = split /\t/; 
	$where_7{$nodec} = $dec;
}

while (<WHERE_6>) {
	chomp;
	($nodec, $dec) = split /\t/; 
	$where_6{$nodec} = $dec;
}

while (<WHERE_5>) {
	chomp;
	($nodec, $dec) = split /\t/; 
	$where_5{$nodec} = $dec;
}

while (<WHERE_4>) {
	chomp;
	($nodec, $dec) = split /\t/; 
	$where_4{$nodec} = $dec;
}

while (<WHERE_3>) {
	chomp;
	($nodec, $dec) = split /\t/; 
	$where_3{$nodec} = $dec;
}

while (<VC>) {
	chomp;
	next if ($_ =~ /^\#/); 
	$ends_in_vow_con{$_}++;
}

while (<CV>) {
	chomp;
	$begs_with_con_vow{$_}++;
}

1;
