#!usr/bin/perl

#Cluster subroutine required for Norwegian decomposition tool

##########################################################################################
#Decopmpose on the basis of consonant clusters

sub cluster {
   my $wd = shift;
   my $orig = $wd;
   
   print LOGG "Entered sub cluster with $wd\n" if $lg;
   
   return $wd if ($wd !~ /[a-z]/);		#*LO-lederen

   #general word-final replacement (undervann~s+skrog)
   $wd =~ s/($db_con)s$/$1~s/;

   #Find relevant cluster
   #make list of relevant clusters in word, ie word-medial ones (after ending strip)
   $tmp = $wd;
   $tmp =~ s/^($prefix)//;	# get rid of possible initial prefix; added 15/11
   $tmp =~ s/($suffix)$//;	# get rid of possible final suffix; added 15/11
   $tmp =~ s/^($con)+//;	# get rid of possible initial consonants
   $tmp =~ s/^($vow)+//;	# get rid of possible initial vowels
   $tmp =~ s/($con)+$//;	# get rid of possible final consonants
   $tmp =~ s/($vow)+$//;	# get rid of possible final vowels
   #all remaining clusters should be analysed
   $tmp =~ s/($vow)+//g;
      
   @relevant_clusters = split "", $tmp;
   foreach $cl (@relevant_clusters) {
      $ocl = $cl;
      
      next if ($cl =~ /[\+~]/);
      
      print LOGG "cluster: $cl\n";
   
      #General substitutions
      if ($cl =~ s/($db_con)s/$1~s\+/) {$wd =~ s/$ocl/$cl/; print LOGG "RULE 1 $cl\n"; next}	# lnn~s+kostnad
      if ($cl =~ s/^($db_con)($con)/$1\+$2/) {$wd =~ s/$ocl/$cl/; print LOGG "RULE 2 $cl\n"; next}	# fregatt+modulene
      if ($cl =~ s/($init)+($fin)/$1\+$2/) {$wd =~ s/$ocl/$cl/; print LOGG "RULE 3 $cl\n"; next}	# angst+skrik
      
      #Cluster by number of characters
      #1
      if ($cl =~ s/^(h|j)$/\+$1/)	{$wd =~ s/$ocl/$cl/; print LOGG "RULE 4\n"; next}	# presse+journalist, prinse+hytta
      if ($cl =~ /^.$/) {print LOGG "RULE 5 $cl\n"; next}
      
      #2
      elsif ($cl =~ /^..$/) {
         if ($cl !~ /($legal|$db_con)/) {$cl =~ s/^(.)(.)/$1\+$2/; $wd =~ s/$ocl/$cl/; print LOGG "RULE 7\n"; next;} # hav+milj
      }
   	
      #3
      elsif ($cl =~ /^...$/) {
         if ($cl =~ s/(.)s(.)/$1~s\+$2/) {$wd =~ s/$ocl/$cl/; print LOGG "RULE 8\n"; next}	# tal~s+mann
         if ($cl =~ s/($fin)(.)/$1\+$2/) {$wd =~ s/$ocl/$cl/; print LOGG "RULE 9\n"; next}	# miljvern+minister
         if ($cl =~ s/(.)($init)/$1\+$2/) {$wd =~ s/$ocl/$cl/; print LOGG "RULE 10\n"; next}	# kron+prinsen
      }
   

      #4
      elsif ($cl =~ /^....$/) {
         if ($cl =~ s/(.)s($init)/$1~s\+$2/) {$wd =~ s/$ocl/$cl/; print LOGG "RULE 11\n"; next}	# dag~s+presse
         if ($cl =~ s/($fin)($init)/$1\+$2/) {$wd =~ s/$ocl/$cl/; print LOGG "RULE 12\n"; next}	# fast+sltt
      }


      #5
      elsif ($cl =~ /^.....$/) {}
      
      #6
      elsif ($cl =~ /^......$/) {}
      
      #>6
      else {}
      
      $wd =~ s/$ocl/$cl/;
   
   }
   
   #Postfixes
#   $wd =~ s/($prefix)\+/$1/g;			# opp*+gjr
#   $wd =~ s/\+($suffix)/$1/g;			# kost*+nad

   print LOGG "$wd before return cluster\n" if $lg;
   return $wd;

} #end sub cluster
##########################################################################################

1;
