#!perl -w

############ SUBS ###############

sub vips {

	my ($ort,$trk,$par,$dec) = @_;
#	my @ll = @_;
#	my ($ort,$trk,$par,$dec) = @ll[1,3,10,2,20];
	my $finalret = "";
#	my @retposts = "";
	$par =~ s/-ett//g;
	$par =~ s/-tu//g;
	$par =~ s/-tre//g;
	my @paradigms = split /,/,$par;
	print LOG "\nIn sub vips:\n----------------\n\nDEC IS $dec\nSplitting the paradigm argument string \'$par\' into the list \@paradigms=\(@paradigms\)\n\n" if $printlog;
	foreach $pfull (@paradigms) {
		unless ($pfull =~ /^c/) {
			print LOG "\nNow treating the word $dec according to paradigm code $pfull:\n\n\n" if $printlog;
			my ($retstring,@ruleitem) = &GetRule($ort,$pfull,$trk);
			$finalret .= "\n$retstring\n\n";
			print LOG "\n\nBack to main loop in sub \'vips\' after getting the appropriate rule or an error message.\nNow we will enter the inflection engine\n" if $printlog;
			print LOG "Calling Inflect($ort,$trk,$pfull,@ruleitem[0,3..$#ruleitem])\n\n" if $printlog;
			my $inflectret = &Inflect(@ll,$ort,$trk,$pfull,$dec,@ruleitem[0,3..$#ruleitem]);
			$finalret = "$inflectret\n$finalret\n\n";
#			$arild .= "\n";
#			my $returnstring = "INARGUMENT:   @ARGV\n\n$finalret\n-----------------------------------------------------------\n";

		} # end unless
	} # end foreach	
	#$arild .= "=======================================================\n";
	return $finalret;
#	else {return ($finalret,())}
#	return $returnstring;
} # end sub



sub OLD_RemSyll {   #moved to lang specific file
	my $trkstem = shift;
	print LOG "For the trkstem $trkstem we remove syllable marker " if $printlog;
	my $m = "";
	if ($trkstem =~ /\.([^\.]*)$/) {
		$m = $1;
		unless ($m =~ /\'2/) {$trkstem =~ s/\.([^\.]*)$/$m/}
	}
	print LOG "and obtain $trkstem\n" if $printlog;
	return $trkstem;
} # end sub


sub Inflect {
	my ($ortending,$trkending,$morftag);
#	foreach $i (0..20) {$ll[$i] = shift} 
	my $bwfull = shift;
	my $bt = shift;
	my $full_paradigm_name = shift;
	my $dec = shift;
	my $pname = shift;
	my $bwsuff = shift;
	$bwsuff =~ s/([\+])/\\$1/g;
#	$bwsuff =~ s/[\+]/\\\1/g;
	my $btsuff = shift;
	$btsuff =~ s/([\+])/\\$1/g;
	my @ruleitems = @_;
	my $ret = "";
	my $bw = $bwfull;
	$bw =~ s/\#.*$//;
	$dec =~ s/\#.*$//;
	
	#$arild .= "bw=$bw\tbt=$bt\t";
	
	print LOG "Now we have entered sub Inflect and know the following:\n" if $printlog;
	print LOG "  orthography=$bw\n  ortogr. sufix=$bwsuff\n  transkription=$bt\n  transkr. suffix=$btsuff\n  subrule in use=$pname\n\n" if $printlog;
	
	print LOG "This means we can calculate a technical stem for orthography and transcription\n" if $printlog;
	print STEMS "=Inflecting $bw ( $dec ) with $pname:\n\n" if $printstems;	
	
	unless ($bw =~ /^(.*)($bwsuff)$/) {
		#$arild .= "C ERROR!";
		print LOG "Oops, no orth. match, returns an ERROR\n\n" if $printlog;
		return "ERROR in wordstem making pattern for $bwfull and $pname(Inflect)\n";
	}
	my $wordstem = $1;
	#$arild .= "ortstem=$wordstem\t";
	print LOG "  orth. stem=$wordstem\n" if $printlog;
	unless ($bt =~ /^(.*)($btsuff)$/) {
		#$arild .= "D ERROR!";
		print LOG "Oops, no trk. match, returns an ERROR\n\n" if $printlog;
		return "ERROR in trkstem making pattern for $bwfull and $pname (Inflect)\n"
	}
	my $trkstem = $1;
	print LOG "  trk. stem=$trkstem\n" if $printlog;
	#$arild .= "trkstem=$trkstem\tdec=$dec\tpname=$pname\t";

	undef $globsubrule;
	$globsubrule = $pname;

	$ret .= "Decomp:   $dec\n";   # XXX
	$ret .= "Rule applied:   $pname\n";
	$ret .= "Baseform entry:   $bwfull    (  $wordstem  +  $bwsuff  )\n";
	$ret .= "Transcription:   $bt    (  $trkstem  +  $btsuff  )\n\n";

	print LOG "\nNow, for every triplet ortsuff---trksuff---tag in the subrule in use, we \n" if $printlog;
	print LOG "paste the ortsuff to the ortstem, the trksuff to the trkstem and name this inflected form \'tag\'\n" if $printlog;
	print LOG "Additionally we apply some general rules to the trk and some rules depending on lexikal info\n\n" if $printlog;
	
	#$currarild = $arild;
	#$arild = "";
	while (@ruleitems) {
		
		$ortending = shift @ruleitems;
		$trkending = shift @ruleitems;
		$morftag = shift @ruleitems;
		
		$ret .= &processes($wordstem,$ortending,$trkstem,$trkending,$morftag,$full_paradigm_name);
		#$arild .= "proc=".$currarild.&processes($wordstem,$ortending,$trkstem,$trkending,$morftag,$full_paradigm_name);
	} # end while
	
	print STEMS "\n=====================================================================\n\n" if $printstems;
	
#		while (@rest) {$ret .= $pre.(shift @rest)."\t".&accsh($tpre.(shift @rest),$p)."\t".$morf_descr{shift @rest}."\n";}
	return $ret;
}

sub MkLexHash {
	my ($lexfile,$line,@ll,$ort,%lexhash);
	$lexfile = shift;
	open LEX,"$lexfile";
	while (<LEX>) {
		chomp;
		$line = $_;
		@ll = split /\t/;
		$ort = $ll[0];
#		$ort =~ s/\#.*$//;
		$lexhash{$ort} .= $line;
	} # end while
	close LEX;
	return %lexhash;

} # end sub


sub OLD_MkRuleHash {
	my ($line,%rules,$rule,$rulefile);
	$rulefile = shift;
	open RULES,"$rulefile";
	while (<RULES>) {
		$line = $_;
		if (/^[\#\s\-]/) {next}
		if (/\[(.+)\]/) {$rule = $1;next}
		$rules{$rule} .= $line;
	}
	close RULES;
	return %rules;
} # end sub


sub MkRuleHash {
	my ($line,%rules,$rule,$rulefile);
	$rulefile = shift;
	open RULES,"$rulefile";
	while (<RULES>) {
		$line = $_;
		if (/^[\#\s\-]/) {next}
		if (/\[(.+)\]/) {$rule = $1;next}
		$rules{$rule} .= $line;
	}
	close RULES;
	return %rules;
} # end sub

sub PreprocessRule {
	my (%substs,$pargroup,$s,$alias,$subs,$paradigm);
	my %rulehash = @_;
	$rulehash{'preprocessing'} =~ s/([\+\~])/\\$1/g;
	my @preprocessings = split /\n+/,$rulehash{'preprocessing'};
	foreach $pp (@preprocessings) {
#		print "pp  =  $pp\n";
		($alias,$subs) = split /\s*=\s*/,$pp;
		$subs =~ s/ +/\|/g;
#		print "$alias : \\\($subs\\\)\n\n";
		$substs{$alias} = "\($subs\)";
		$substs{$alias} =~ s/\(\)//;
	}
	
	delete $rulehash{'preprocessing'};
	foreach $pargroup (keys %rulehash) {
		foreach $s (keys %substs) {$rulehash{$pargroup} =~ s/$s/$substs{$s}/g;}
	}
	
	return %rulehash;
} # end sub




sub GetRule { # must know global %rules
	my ($rule,@ruleitem,$bwstem,$bwsuff,$x3,$x4,$x5,$x6,$x7,$x8,$btstem,$btsuff,$ii);
	my ($bwfull,$pdgm_in,$bt) = @_;
	$bw = $bwfull;
	$bw =~ s/\#.*$//;
	my $pdgm = $pdgm_in;
	$pdgm =~ s/[]//g;
	$pdgm =~ s/\-(noll|ett|tu|tre)$//;
	print LOG "Entered GetRule($bwfull,$pdgm_in,$bt)\n" if $printlog;
	print LOG "Trying to find \$rules\{$pdgm\}\n" if $printlog;
	
	if (exists $rules{$pdgm}) {
		print LOG "...and found it. Now traversing the subrules for matches...\n\n" if $printlog;
		foreach $rule (split /\n/,$rules{$pdgm}) {
			print LOG "\nTrying subrule...\n   $rule\n" if $printlog;
			$retstring = "ERROR!!!";
#			$rule = &PreprocessRule($ruleA);
#			print LOG "...and preprocessing it into\n   $rule\n" if $printlog;
#			print STDOUT "$bw\nrule:  $ruleA\nrule :  $rule\n";
			@ruleitem = split /\t/,$rule;
			my @org_ruleitem = @ruleitem;
			
			$x3=$x4=$x5=$x6=$x7=$x8="";
			unless ($bw =~ /^(.*)($ruleitem[1])$/) {print LOG "Failed to match the end of $bw with $ruleitem[1], so we try the next rule...\n" if $printlog;next}
			$x3=$3 if $3; $x4 = $4 if $4; $x5 = $5 if $5;
			print LOG "Succeeded to match $bw with $ruleitem[1], and made the following instantiations:\n   set   1 to $x3\n   set  2 to $x4\n   set 3 to $x5\n" if $printlog;
			unless ($bt =~ /^(.*)($ruleitem[2])$/) {print LOG "...but failed to match the end of $bt with $ruleitem[2]\n" if $printlog;next}
			$x6=$3 if $3; $x7 = $4 if $4; $x8 = $5 if $5;
			print LOG "... AND succeeded to match $bt with $ruleitem[2], and made the following instantiations:\n   set   1 to $x6\n   set  2 to $x7\n   set 3 to $x8\n" if $printlog;

			print LOG "\nNow, replace the occuranses of 1 and 1 \'placeholders\' in the rest of the rule with their respective instantiation...\n" if $printlog;

			foreach $ii (0,1,2,3..$#ruleitem) {
				$ruleitem[$ii] =~ s/3/$x5/g;
				$ruleitem[$ii] =~ s/2/$x4/g;
				$ruleitem[$ii] =~ s/1/$x3/g;
				$ruleitem[$ii] =~ s/3/$x8/g;
				$ruleitem[$ii] =~ s/2/$x7/g;
				$ruleitem[$ii] =~ s/1/$x6/g;
			} # end foreach $ii
			
			my $tempruleitem = join "\t",@ruleitem;

			print LOG "\nThe matching rule has now been through two stages:\n" if $printlog;
			print LOG "1-matching:        $rule\n" if $printlog;
#			print LOG "2-preprocessing:   $rule\n" if $printlog;
			print LOG "2-instantiating:   $tempruleitem\n" if $printlog;


#			print STDOUT "ruleitem:  @ruleitem\n\n";

			$retstring = ""; 
			$retstring .=  "\n==========================================\n      Treatment of entry   $bwfull   $pdgm($pdgm_in)   $bt\n===================================\n";
			$retstring .=  "Matching criteria word = $ruleitem[1]\n";
			$retstring .=  "Matching criteria trk  = $ruleitem[2]\n";
#			$retstring .=  "Word (stem+suff)=$bwstem + $bwsuff\n";
#			$retstring .=  "Trk  (stem+suff)=$btstem + $btsuff\n";
			$retstring .=  "We started with the following orig. rule:\n@org_ruleitem\n";
			$retstring .=  "Rule processing :\n";
			$retstring .=  "   1 --> $x3\n   2 --> $x4\n   3 --> $x5\n   1 --> $x6\n   2 --> $x7\n   3 --> $x8\n";
			$retstring .=  "And so we end up with the following rule:\n@ruleitem\n";
			last;
		} # end foreach $rule
	} # end if exists
	else {print LOG "Unfortunately, paradigm $pdgm is not yet implemented!!\n\n" if $printlog;return ("\n==========================================\n      Treatment of entry   $bwfull   $pdgm($pdgm_in)   $bt\n===================================\nERROR: no rules defined for paradigm $pdgm\n\n",())}
	return ($retstring,@ruleitem);
} # end sub


# Not in use
sub just_doit {
	my ($listel,$outel,$ret);
	my $wd = shift;
	my $prelhs = &x_ify_lh($wd);
	
#LW	my $lhs = &retroflex_transform($prelhs);
	my $lhs = $prelhs;
	
	my @lhs_list = split /x530/,$lhs;
	my @syllabified = ();
	foreach $listel (@lhs_list) {push @syllabified,&syllabify($listel)} # end foreach
	my $syllabified = join "x530",@syllabified;
	$syllabified =~ s/^x//;
	my @out = split /x/,$syllabified;
	my $convertedstring = "";
	foreach $outel (@out) {
		if (exists $map{$outel}) {$convertedstring .= $map{$outel}}
		else {
			$ret = "SYMBOL ERROR $outel in $wd\n";
			return $ret
		} # end else
	}
	my $outstring = "$convertedstring";
	return $outstring;

} # end sub


sub just_doit2 {
	my ($listel,$outel,$ret,$indexstring,$untouched,$touched);
	my $wd = shift;
	my $nr_of_sylls = shift;
	my $index = q/|||||\#|/;
	# temporarily remove indexes
	if ($wd =~ /^(.+?)(($index)*)$/) {
		$indexstring = $2;
		$wd = $1;
	}
	else {$indexstring = "";}
	# get the part to syllabify
	my @sylls = split /\./,$wd;
	if ($nr_of_sylls > 1) {
		$untouched = join ".",@sylls[0..($nr_of_sylls-2)];
		$touched = join ".",@sylls[($nr_of_sylls-1)..$#sylls]
	}
	else {
		$untouched = "";
		$touched = $wd;
	}
	
	$t->insert("end","(just_doit2 is operating on $touched)\n") if $winlog;
	
	my $prelhs = &x_ify_lh($touched);
	
	$t->insert("end","prellhs:   $prelhs\n") if $winlog;
	
	
#LW	my $lhs = &retroflex_transform($prelhs);
	my $lhs = $prelhs;
	
	my @lhs_list = split /x530/,$lhs;
	my @syllabified = ();
	foreach $listel (@lhs_list) {
		push @syllabified,&syllabify($listel);
		
	} # end foreach
	my $syllabified = join "x530",@syllabified;
	
	$t->insert("end","syllabified:   $syllabified\n") if $winlog;
	
	$syllabified =~ s/^x//;
	my @out = split /x/,$syllabified;
	my $convertedstring = "";
	foreach $outel (@out) {
		if (exists $map{$outel}) {$convertedstring .= $map{$outel}}
		else {
			$ret = "SYMBOL ERROR $outel in $wd\n";
			return $ret
		} # end else
	}
	
	# Ugly fix to avoid syllabification in word boundaries
	$convertedstring =~ s/([\_\"]+)\./$1/g;
	
	my $outstring = "$convertedstring";
	return $untouched.".".$outstring.$indexstring if $untouched;
	return $outstring.$indexstring;

} # end sub







sub OLD_retr {
	my $lh = shift;
	my $in_lh = $lh;
	my $stress_or_syll = "2\\'|\\'2|\\'|\\.";
	my $retrCs = "d|t|s|n";
	$lh =~ s/:r(($stress_or_syll)*)($retrCs)([^\+]|$)/:$1$3\+$4/g;
	foreach (0..4) {
		$lh =~ s/(($retrCs)\+($stress_or_syll)*($retrCs))([^\+]|$)/$1\+$5/g;
	} # end foreach
	
	if ($lh ne $in_lh) {print STDOUT "RETR HAS CHANGED $in_lh TO $lh\n"}
	
	return $lh;
} # end sub



1;