# Subrutiner for  opne hjelpvindu

my $helpfile = "guinflect.hlp";
my $filepos = 0;
my $helptext = "";  #  Innholdet i hjelpfila
my $curr_block = "index";  # Blokk av hjelpfil som skal visast
my $prev_block = "index";  # Forrige hjelpfil-blokk
my @help_tags = ("title");

sub help_window {
    my $mw = $_[0];
    my $tl = $mw->Toplevel(-takefocus => 0);
    my $text = $tl->Text(-font => "Arial 14 normal", -takefocus => 0)->pack();
    $tl->protocol(WM_DELETE_WINDOW, [\&close_wnd, $tl, $text]);
    #  Lag tags
    $text->tagConfigure("title", -font => "Arial 18 bold", -lmargin1 => 10);
    $text->tagConfigure("top", -underline => 1, -foreground => "blue");
    $text->tagBind("top", "<Button-1>", [\&goto_link, "index"]);
    $text->tagConfigure("prev", -underline => 1, -foreground => "blue");
    $text->tagBind("prev", "<Button-1>", [\&goto_link, $prev_block]);

    &readHelpfile($text);
    &parseHelptext($text);
    $tl->deiconify();
    $tl->raise();
}
    
sub readHelpfile {
    my $text = $_[0];
    open (FILE, $helpfile) || die "Kan ikkje opne fil $helpfile, $!\n";
    undef $/;
    $helptext = <FILE>;
    close FILE;
}

sub parseHelptext {
    my $text = $_[0];
    my $block = "";
    my $line = "";

    #  Slett gammel tekst og gamle link-tags
    $text->delete("1.0", 'end');
    foreach($text->tagNames()) {
	$text->tagDelete($_) if (/^a\ /);
    }
    if ($helptext=~/\[$curr_block\](.*?)\[\/$curr_block\]/s) {
	$block = $1;
    }
    else {
	$text->insert("1.0", "Feil under lesing av hjelpfil");
	return -1;
    }
    #  Skriv navigasjons-linker p toppen av sida
    $text->insert('end', "Navigate:  ");
    $text->insert('end', "prev", "prev");
    $text->insert('end', "     ");
    $text->insert('end', "top", "top");
    $text->insert('end', "\n");
    foreach $line (split("\n", $block)) {	
	if ($line !~/^\#/) { #  Alle linjer som starter med # blir ignorert
	    $found = 0;
	    #  Hvis linja inneholder link-tags (<a ...>), 
	    #  lag ein tilsvarande Tk-tag 
	    if ($line=~/\<(a\ .*?)\>(.*?)\<\/a\>/) {
		my $pre_tag = $`;
		my $tag_start = $1;
		my $tag_text = $2;
		my $post_tag = $';
		if ($tag_start =~/ref/) { # Hvis linja inneholder ein link-tag.
		    $tag_start=~/\s*\=\s*\"(.+?)\"/;
		    #  Lag tag og bind musklikk
		    $text->tagConfigure($tag_start,
					-underline => 1,
					-foreground => 'blue',
					);
		    $text->tagBind($tag_start, "<Button-1>", [\&goto_link, $1]);
		    $text->insert('end', $pre_tag);
		    $text->insert('end', "$tag_text", $tag_start);
		    $text->insert('end', "$post_tag\n");
		}
	    }
	    else {
		foreach(@help_tags) {
		    if ($line=~/\<$_\>(.*?)\<\/$_\>/) {
			$text->insert('end', $`);
			$text->insert('end', "$1", $_);
			$text->insert('end', "$'\n");
			$found = 1;
			last;
		    }
		}
		if (!$found) {
		    $text->insert('end', "$line\n");
		}
		else {
		    $found = 0;
		}
	    }
	}
    }
}

sub goto_link {
    my $text = shift;
    $prev_block = $curr_block;
    $curr_block = $_[0];
    $text->tagBind("prev", "<Button-1>", [\&goto_link, $prev_block]);
    &parseHelptext($text);
}

sub close_wnd {
    my $tl = shift;
#    $curr_block = $prev_block = "index";
    $tl->destroy();
}
1;




