# !perl -w

#Programmet analyserer alle dekomponerte ikke-garbage ord, 
#og klassifiserer forledd ut fra hvordan de danner sammensetninger.
#Tilordner koder etter fuge, og skriver til n liste. 

open LEX, "simplex.txt";
open IN, "dekomponerte_fellesnavn.txt";

#open LOGG, ">logg.OUT";
open OUT, ">fl_lh_no_full.LEX";
open MISS, ">missing_simplex.txt";

@longlist = "";

$fuge = "(a|ar|e|en|er|es|n|r|s|-)";
%fugehash = qw(a	c1
	ar	c2
	e	c3
	en	c4
	er	c5
	es	c6
	n	c7
	r	c8
	s	c9
	-	c10);



%fugetrans = qw(a	A
	ar	Ar6
	e	E
	en	En
	er	Er6
	es	Es
	n	n
	r	r6
	s	s
	-	);


$punc = "_|-|!";

while (<LEX>) {
	chomp;
	@field = split ";", $_;
	$lexhash{$field[1]} = $field[11];
}

while (<IN>) {
	$code = "";
	chomp;
	$linje = $_;
	@felt = split ";", $linje;
	$corr = $felt[1];		#ortografi
	$decomp = $felt[2];		#dekomponering
	$pos = $felt[3];
	$decpos = $felt[4];
	$trans = $felt[11];
	$id = $felt[40];
	@ortledd = split /\+/, $decomp;		#hvert dekomponeringsledd

#print LOGG "New entry:\t$corr\t$decomp\n";

	for ($i = 0; $i < 10; $i++) {
		$curr = $ortledd[$i];
		$n = $i+1;
		$m = $i+2;
		$next = $ortledd[$n];
		$mext = $ortledd[$m];
#print LOGG "\$curr:\t$curr\n";
#print LOGG "\$next:\t$next\n";
#print LOGG "\$mext:\t$mext\n";

		if (($curr !~ /^$punc/) && ($next !~ /^$fuge$/) && ($next) && ($curr !~ /^$fuge$/)) {
			$code = "c0";

			$lccurr = lc $curr;
			$uccurr = ucfirst $curr;
			
			if (exists $lexhash{$curr}) {
				$trans1 = $lexhash{$curr};
			}

			elsif (exists $lexhash{$lccurr}) {
				$trans1 = $lexhash{$lccurr};
			}

			elsif (exists $lexhash{$uccurr}) {
				$trans1 = $lexhash{$uccurr};
			}
			
			else {print MISS "$linje\n"};
			
			
			$item = "$code"."\t$curr"."\t$trans1"."\t$curr"."\t$trans1"."\t$pos"."\t$decomp"."\t$id";
			push @longlist, $item;
		}
		
		elsif (($curr !~ /^$punc/) && ($next =~ /^$fuge$/) && ($next)) {
			$forledd = $curr.$next;

			if (exists $lexhash{$forledd}) {
				$trans1 = $lexhash{$forledd};
			}
			
			elsif (exists $lexhash{$curr}) {
				$trlink = $fugetrans{$next};
				$trans1 = "$lexhash{$curr}"."$trlink";
			}
			
			else {print MISS "$linje\n"};
			
			$trans2 = $lexhash{$curr};

			$code = $fugehash{$next};
			$item = "$code"."\t$forledd"."\t$trans1"."\t$curr"."\t$trans2"."\t$pos"."\t$decomp"."\t$id";
			push @longlist, $item;
		}
	}

#print LOGG "--------------\n";

}

foreach $entry (sort @longlist) {
	print OUT "$entry\n";
}
