# !perl -w

#Programmet analyserer alle dekomponerte ikke-garbage ord, 
#og klassifiserer forledd ut fra hvordan de danner sammensetninger.
#Tilordner koder etter fuge, og skriver til n liste. 

open LEX, "simplex.txt";
open IN, "dekomponerte_fellesnavn.txt";

open LOGG, ">logg.OUT";
open OUT, ">fl_lh_no.LEX";
open MISS, ">missing_simplex.txt";

%longlist = "";

$fuge = "(a|ar|e|en|er|es|n|r|s|-)";
%fugehash = qw(a	c1
	ar	c2
	e	c3
	en	c4
	er	c5
	es	c6
	n	c7
	r	c8
	s	c9
	-	c10);



%fugetrans = qw(a	A
	ar	Ar6
	e	E
	en	En
	er	Er6
	es	Es
	n	n
	r	r6
	s	s
	-	);


$punc = "_|-|!";

while (<LEX>) {
	chomp;
	@field = split ";", $_;
	$lexhash{$field[1]} = $field[11];
}

while (<IN>) {
	$code = "";
	$curr = "";
	$lccurr = "";
	$uccurr = "";
	$trans1 = "";
	$trans2 = "";

	chomp;
	$linje = $_;
	@felt = split ";", $linje;
	$corr = $felt[1];		#ortografi
	$decomp = $felt[2];		#dekomponering
	$pos = $felt[3];
	$decpos = $felt[4];
	$trans = $felt[11];
	$id = $felt[40];
	@ortledd = split /\+/, $decomp;		#hvert dekomponeringsledd

print LOGG "New entry:\t$corr\t$decomp\n";

	for ($i = 0; $i < 10; $i++) {
		$curr = $ortledd[$i];
		$n = $i+1;
		$m = $i+2;
		$next = $ortledd[$n];
		$mext = $ortledd[$m];
print LOGG "\$curr:\t$curr\n";
print LOGG "\$next:\t$next\n";
print LOGG "\$mext:\t$mext\n";

		if (($curr !~ /^$punc/) && ($next !~ /^$fuge$/) && ($next) && ($curr !~ /^$fuge$/)) {
			$code = "c0";

			$lccurr = lc $curr;
			$uccurr = ucfirst $curr;
			
			if (exists $lexhash{$curr}) {
				$trans1 = $lexhash{$curr};
print LOGG "Found \$curr:\t$curr\t$lexhash{$curr}\t$curr + $next + $mext\n";
			}

			elsif (exists $lexhash{$lccurr}) {
				$trans1 = $lexhash{$lccurr};
print LOGG "Found \$lccurr:\t$lccurr\t$lexhash{$lccurr}\t$curr + $next + $mext\n";
			}

			elsif (exists $lexhash{$uccurr}) {
				$trans1 = $lexhash{$uccurr};
print LOGG "Found \$uccurr:\t$uccurr\t$lexhash{$uccurr}\t$curr + $next + $mext\n";
			}
			
			else {print MISS "$linje\n"};

print LOGG "\$code=$code\t\$trans1=$trans1\n";
			
			if ($trans1) {
				$item = "$code"."\t$curr"."\t$trans1"."\t$curr"."\t$trans1"."\t$pos"."\t$decomp"."\t$id";
				$longlist{$curr} = $item;
			}
		}

		elsif (($curr !~ /^$punc/) && ($next =~ /^$fuge$/) && ($next)) {
			$forledd = $curr.$next;

			if (exists $lexhash{$forledd}) {
				$trans1 = $lexhash{$forledd};
print LOGG "Yo! Found \$forledd:\t$forledd\t$lexhash{$forledd}\t$curr + $next + $mext\n";
			}
			
			elsif (exists $lexhash{$curr}) {
				$trlink = $fugetrans{$next};
				$trans1 = "$lexhash{$curr}"."$trlink";
print LOGG "Hey! Found \$curr:\t$curr\t$lexhash{$curr}\t$curr + $next + $mext\n";
			}
			
			else {print MISS "$linje\n"};
			
			$trans2 = $lexhash{$curr};
			$code = $fugehash{$next};

print LOGG "\$code=$code\t\$trans1=$trans1\t\$trans2=$trans2\n";
			
			if (($trans1) && ($trans2)) {
				$item = "$code"."\t$forledd"."\t$trans1"."\t$curr"."\t$trans2"."\t$pos"."\t$decomp"."\t$id";
				$longlist{$forledd} = $item;
			}
		}
	}

print LOGG "--------------\n";

}

foreach $key (sort keys %longlist) {
	print OUT "$longlist{$key}\n";
}
