#!perl -w

##########################################################################
#	recompounder_lh.pl
#	Skaper transkripsjoner av en dekomponert sammensetning (vare+bil)
#	For-/mellomledet sls opp i fl.LEX
#	Etterledet sls upp i simplex.txt.
#	Dette er den norske verjonen av hopsettaren. 
#	040401: GA
###########################################################################


#############################LOGGSKRIVING#################################
#sett loggskrivingsparameter her
$logg = 0;
open LOGG, ">hopsettar_logg.OUT" if $logg;
###########################################################################


#############################UTFIL#########################################
open OUT,">recompounder_lh.OUT";
###########################################################################


%map = qw(
151	E&U0
153	E+&Y
930	n+%\)
940	l+%\)
152	E&I
154	A&I
155	O&I
190	t&S
910	n%\)
920	l%\)
050	u0:
090	e+:
010	A:
020	e:
030	i:
040	u:
060	y:
070	o:
081	@:
221	U0
091	E+
100	d+
110	t+
130	n+
140	l+
400	nK
421	r6
510	2'
520	'2
181	A
200	I
210	U
230	Y
240	O
250	E
270	b
280	d
290	g
300	p
310	t
320	k
330	f
340	s
341	S
360	V
370	C
380	m
390	n
410	l
430	h
440	j
500	'
530	.
550	_
570	"
);

#Endret SE
%devoice = ("b","p","d","t","g","k","V","f");

#Endret SE
%special_lmcc =  ("2\'r6i:ks","2\'r6Iks","r6i:ks","r6Iks");

#Endret SE
$shortvowel = "(A|E|I|U|U0|Y|E+|O)";

#Endret SE
$prefiks = '2\'Al|\'An.tI|2?\'AnK|2?\'An|2?\'A:V|(2)?\'bi:|(2)?\'bUt\+|\'Ci:.lU|2\'de:l|\'de:\.sI|\'di:t|2\'E\.tEr6|2\'e:n |2\'e:r6|\'Eks|2\'Ek\.str6A|\'fAst|2\'fle:r6|'.
	'2\'fUt+|2\'fe\+:r6|2\'fo:\.r6E|\'fO\.r6U0|2?\'gu:|2?\'jEn|2\'jE\.nOm|2?\'hE\.?\'?2?n|2\'hi:t|\'hy:.pEr6|'.
	'2\'I\.kE|2\'InK|2?\'In|\'kOn\.tr6A|2\'V@:r6|\'kVA:\.sI|\'mA:\.kr6U|\'mA.kr6U|\'mAk\.sI|2?\'me:\.?d|\'mI\.dEl|'.
	'2\'mE\.lOm|\'mi:\.dI|\'mI\.lI|\'mi:\.kr6U|\'mI\.kr6U|\'mi:\.nI|2\'mIs|2?\'mu:t|\'mU0l\.tI|2\'mAnK|\'ne:d|'.
	'\'ne:\.U|2?\'Om|\'pr6u:|\'p?sE\&U0.dU|\'p?sE\&U0.dO|\'p?sEV.dU|\'p?sEV.dO|2?\'po:|2\'sAm|\'se:\.mI|\'sEn\.tI|\'su0:\.pEr6|'.
	'2\'s@:r6|2?\'tI\.?\'?2?l|\'tr6I\.pEl|2\'tu:|2\'tVe:|\'U0l\.tr6A|2\'Um|2?\'U0n|2\'U0n\.dEr6|2\'U0\.nEr6|'.
	'2?\'O\.?\'?2?p|2\'u0:r6|2?\'u0:\.?\'?2?t|2\'VAnK|2\'VAn|2\'V@:r6|2\'Vi:\.sE|2\'Vi:\.dE.r6E|2\'Er6\.kE|2\'o:\.VEr6';

#Endret SE
$suffiks = '(mo:\.?l(Er6|E|E\.nE)?)s?|(kO\.?n(Er6|E|E\.nE)?)s?|(pUnKk\.?t(Er6|E|E\.nE)?)s?|((s|t)(i:|I)\.?V(En|Er6|E|t|E\.nE)?)s?|((s|S)kA:\.?p(En|Er6|E|E\.nE)?)s?|(d\+?A:\.?g(En|Er6|E\.nE)?)s?|(he:\.?t(En|n%\)|n%\)\.E|Er6|E\.nE)?)s?';
#$suffiks = '(mo:\.?l(Er6|E|E\.nE)?)s?|(kO\.?n(Er6|E|E\.nE)?)s?|(pUnKk\.?t(Er6|E|E\.nE)?)s?|((s|t)(i:|I)\.?V(En|Er6|E|t|E\.nE)?)s?|(skA:\.?p(En|Er6|E|E\.nE)?)s?|(d\+?A:\.?g(En|Er6|E\.nE)?)s?|he:ts?|he:\.tEns?|he:\.tn%\)s?|he:\.tE\.nEs?|he:\.tn%\)\.Es?';

$special_word = '####';
$endings = 'InK(\.(En|(E|A)r6|(E|A)\.n+E)s?)?|'.	#-ing
	'I\.?g?(E|E\.r6E|E?\.?st(E)?)?|'.	#-ig
	'bi:(t|l)|bi:\.(t|l)(..s?|E\.n(\+)?E)s?|';
$second = '(mI|mAn|t(i:|I)S|Uns|t(u:|U)S\+|fr6e:|le\+:|sE\+n)\.d\+?A:\.g|b(u:|U)k\.st';
$word_last = 'i:\.dr6Et|bO&I\.kOt';

#Endret SE
$tkn = "a-z A-Z 02\'\&\%\)6:\+";
$tkn_no_stress = "a-z A-Z 0\&\%\)6:\+";

#Endret SE
$tonem1 = "\'";
$tonem2 = "2\'";
$bitrykk = "\'2";
$del = "\\.";
$setningstrykk = "\"";
$ordgrense = "\_";

#Endret SE
@il_onsets = qw(
x340x300x421
x340x300x410
x340x300x440
x340x310x421
x340x310x440
x340x320x360
x340x320x421
x340x320x410
x300x421
x300x410
x300x440
x270x421
x270x410
x270x440
x310x421
x310x360
x310x440
x280x360
x280x440
x280x421
x320x390
x320x360
x320x421
x320x410
x290x390
x290x421
x290x410
x380x440
x390x440
x330x390
x330x421
x330x410
x330x440
x360x421
x340x300
x340x310
x340x320
x340x380
x340x390
x340x330
x340x360
x340x410
x341x310
x341x320
x341x410
x300
x270
x310
x280
x320
x290
x380
x390
x330
x360
x421
x340
x341
x370
x430
x410
x440
x100
x110
x130
x140
x190
);


#******************************************* LEKSIKON *********************************************
#alle simpleksord i stora norska leksikonet

#open LEX,"W:\\HOPSETTAR\\simplex.txt";
open LEX,"simplex.txt";

while (<LEX>) {
	chomp;
	@lexline = split /\;/;
	$lexort = $lexline[1];	#$lexort =~ s/\#.*//;
	$lextrk = $lexline[11];
	$lexpos = $lexline[3];
	$lexcode = $lexline[7];
	$lexinfo = $lexline[27]; #if ($lexinfo !~ /[a-z]/) { $lexinfo = "no_teliainfo"; }
	$lexid = $lexline[40];
		
	$lex{$lexort} = "$lexcode--$lexort--$lextrk--$lexpos--$lexinfo--$lexid";	
}

print "Ferdig med lesning av simpleks-leksikon...\n";

#*****************************************FL-LEKSIKON *********************************************
#norsk forleddsleksikon

#open FLLEX,"W:\\HOPSETTAR\\fl_lh_no.LEX";
open FLLEX,"fl_lh_no.LEX";


while (<FLLEX>) {
	chomp;
	($code,$fl,$trk,$lemma_ort,$lemma_trk,$pos,$info,$id) = split /\t/;
	$fl{$fl} = "$code--$fl--$trk--$lemma_ort--$lemma_trk--$pos--$info--$id";
}

print "Ferdig med lesning av forleddsleksikon...\n";

#********************************************* INNFIL **********************************************
#dekomponerte ord fra inflektor'n

#open IN,"W:\\HOPSETTAR\\decomp.txt";
open IN,"new_decomp";
#open IN,"decomp_small.txt";

while (<IN>) {
	@fl_code = ();@fl_ort = ();@fl_trk = ();
	@el_code = ();@el_ort = ();@el_trk = ();
	@dec_lookup = (); @ml = ();@sms_trk = ();
	@ml = (); @codes = (); @orts = (); @trks = ();
	$lemma_ort = ""; $lemma_trk = ""; $trks = ""; $orts = "";
	
	chomp;
	
	#//different from compounder.pl
	($dec,$orig_trk) = split /\t/;
	
#print LOGG "-----\n\n" if $logg;
print LOGG "NEW ENTRY from decomp.txt:\t$dec\t$orig_trk\n" if $logg;

	$orig_dec = $dec;
	@dec = split /\+/,$dec;
	
	$el = pop @dec;		#etterledet
	$el = &lookup($el);	#slr opp i simplex-lexikon

print LOGG "After simplex lexicon lookup of final element: \$el=$el\n" if $logg;

	($lemma_ort,$lemma_trk,@fl) = &fl_lookup(@dec);	#allt utom sista sls upp i fl-lexikon - finner lemmat

	
#//end different from compounder.pl
	
#***************************** FIKSE FORLEDD OG MELLOMLEDD ***************************
print LOGG "Behandler hvert sammensetningsledd\n" if $logg;

	$antal = 0;					#skickas med fr att se om det r fl eller ml
	foreach $fl (@fl) {				#frled + mellanled
print LOGG "Ledd: \$fl=$fl\n\n" if $logg;
		($fl_code,$fl_ort,$fl_trk) = split /--/,$fl;
		
		if ($antal == 0) {				#frled

print LOGG "Sender forleddet $fl_ort med $fl_trk til sub fl_tryck\n" if $logg;

			$fl_trk = &fl_tryck($fl_trk);		#betoning

		} else {					#mellanled

print LOGG "Sender mellomleddet $fl_ort med $fl_trk til sub ml_tryck\n" if $logg;

			$fl_trk = &ml_tryck($fl_trk);		#betoning

		}
	
		push @codes,$fl_code;
		push @orts,$fl_ort;
		push @trks,$fl_trk;
		$antal++;	
	}
#***************************** FIKSE ETTERLEDD ****************************************
	@el = split /--/,$el;					#@el = kod,ort,trk
	
	($lemma_ort,$lemma_trk,$el_code,$el_ort,$el_trk) = &prepare_el($lemma_ort,$lemma_trk,@el);	#gr iordning efterledet
	$el_code =~ s/(.*);c.*/$1/;					#bara ordklasskoden ska vara kvar
		
	push @codes,$el_code;
	push @orts,$el_ort;
	push @trks,$el_trk;

	$codes = join "-",@codes;
	$orts = join "\+",@orts;
	$trks = join "\-",@trks;

print LOGG "\n\$codes = $codes\n" if $logg;
print LOGG "\$orts = $orts\n" if $logg;
print LOGG "\$trks = $trks\n" if $logg;


	if ($trks !~ /not_in_lex/) {
		$trks = &phonology($trks);
#		$trks = &special_trks($trks);		#new 13/2
		#print OUT "$lemma_ort\t$lemma_trk\n";
		#print OUT "$codes\t$orts\t$trks\n";
		if ($trks eq $orig_trk) { 
			print OUT "LIKE:\t$orig_dec\t$trks\t$orig_trk\n"; 
		} else { 
			print OUT "ULIKE:\t$orig_dec\t$trks\t$orig_trk\n"; 
		}
	} #else {print OUT "NOMATCH:\t$orig_dec\t$trks\t$orig_trk\n";}

print LOGG "\n---------------------------------------------------------------------------------------------------------------------------\n" if $logg;
} #end while IN

#******************************** SPECIAL TRKS ***********************************
sub special_trks {						#added 13/2
#NOT IN USE FOR NORWEGIAN
	my $trks = shift;

print LOGG "\nSubroutine special_trks\n" if $logg;
print LOGG "\$trks = $trks at sub special_trks start\n" if $logg;
print LOGG "\$trks = $trks at sub special_trks end\n" if $logg;

	return $trks;
} #end sub
#******************************** FONOLOGISKA PROCESSER ***********************************
sub phonology {
	my $sms_trk = shift;

print LOGG "\nSubroutine phonology\n" if $logg;
print LOGG "\$sms_trk = $sms_trk at sub phonology start\n" if $logg;

	my ($i,$j,$fl,$el);
	@sms_trk = split /-/,$sms_trk;

$i = 0;
$j = 1;

for ($i = 0; $i < $#sms_trk; $i++) {
	$j = $i + 1;
	($fl,$el) = &retr($sms_trk[$i],$sms_trk[$j]);		#retroflection
	($fl,$el) = &velarisering($fl,$el);		#velarising
	$fl = &devoice($fl);			#devoicing
	$fl = &special_lmcc($fl);			#special
	$sms_trk[$i] = $fl; $sms_trk[$j] = $el;
	}

$sms_trk = join "\.",@sms_trk;

print LOGG "\$sms_trk = $sms_trk at sub phonology end\n\n" if $logg;

return $sms_trk;

} #end sub
	
#******************************************** LOOKUP *********************************************
#endast fr efterledet
sub lookup {

#"numeral","noun","adverb","adj","verb","prepostition","interjection","conjunction";
		
		my $el = shift;

		my $lexstuff;
		
		if (exists ($lex{$el})) {
			$lexstuff = $lex{$el};
		} else {
			$lexstuff = "not_in_lex--not_in_lex--not_in_lex--not_in_lex--not_in_lex--not_in_lex";
			}
		return $lexstuff;
		

} #end sub

#**************************************** FL_LOOKUP *********************************************
sub fl_lookup {
	my @dec = @_;
	my ($part,$lexstuff,$lemma_ort,$lemma_trk,@lemma_ort,@lemma_trk);

	foreach $part (@dec) { 
		if (exists ($fl{$part})) {
			$lexstuff = $fl{$part};
		push @dec_lookup,$lexstuff;
		@lexstuff = split /--/,$lexstuff;
		push @lemma_ort,$lexstuff[3];
		push @lemma_trk,$lexstuff[4];
	$lemma_ort = join "\+",@lemma_ort;
	$lemma_trk = join "--",@lemma_trk;
	} else {
			$lexstuff = "not_in_lex--not_in_lex--not_in_lex--not_in_lex--not_in_lex--not_in_lex";
		
			push @dec_lookup,$lexstuff;
		}
		}
	return $lemma_ort,$lemma_trk,@dec_lookup;		
	

} #end sub

#******************************************** ETTERLED *********************************************
sub prepare_el {
	
	my ($lemma_ort,$lemma_trk,$code,$ort,$trk,$pos,$info,$id) = @_;
	
	$lemma_ort .= "+$ort";
	$lemma_trk .= "--$trk";

	$trk = &el_tryck($trk,$ort);						#betoning
	return $lemma_ort,$lemma_trk,$code,$ort,$trk;	
	}
		
#************************************** BETONING *****************************************************		
sub fl_tryck {
	# Endrer hovedtrykk til tonem 2
	# og fjerner bitrykk fra forleddet

	my $fl = shift;

print LOGG "\nSubroutine fl_tryck\n" if $logg;
print LOGG "\$fl = $fl at sub fl_tryck start\n" if $logg;
		
#testet  kommentere bort 17/4
	if ($fl !~ /\./) {
		$fl =~ s/$tonem2/<TRYKK>/;
		$fl =~ s/$tonem1([^2])/<TRYKK>$1/;
		$fl =~ s/$bitrykk//g;
		$fl =~ s/<TRYKK>/$tonem2/;
	}
	else {
		$fl =~ s/$bitrykk//g;
	}
	
		

print LOGG "\$fl = $fl at sub fl_tryck end\n" if $logg;

	return $fl;

} # end sub

sub ml_tryck {
	#fjerner alle trykk fra mellomleddene
	#ok for norsk ogs, da ord skal maksimalt ha ett hovedtrykk og ett bitrykk

print LOGG "\nSubroutine ml_tryck\n" if $logg;
print LOGG "\$ml = $ml at sub ml_tryck start\n" if $logg;

	my ($ml,$ort) = @_;
	$ml =~ s/[$tonem2]//g;		#changed 27/2

print LOGG "\$ml = $ml at sub ml_tryck end\n" if $logg;
	return $ml;

} #end sub


#changed 2/3
sub el_tryck {
	my ($el,$el_ort) = @_;

print LOGG "\nSubroutine el_tryck\n" if $logg;
print LOGG "\$el = $el at sub el_tryck start\n" if $logg;

	if ($el =~ /$suffiks$/) {
print LOGG "\$el = $el at sub el_tryck etter 1. if\n" if $logg;
		$el = &stress_suffix($el,$el_ort);	#flytter trykk til hyre (til -het)
	}
	elsif ($el =~ /$second/) {				#om det brjar p betonbart prefix + stavelsegrns:
print LOGG "\$el = $el at sub el_tryck etter 2. if\n" if $logg;

		$el = &stress_second($el,$el_ort);
	} elsif ($el =~ /$tonem2.*$bitrykk/) {			#$el har bde huvud- och bitryck utsatt
print LOGG "\$el = $el at sub el_tryck etter 3. if\n" if $logg;

		$el = &stress_remove_main($el,$el_ort);	
	} elsif ($el !~ /($tonem2|$bitrykk)/) { 				#$el har bara akut betoning
		$el = &stress_main($el,$el_ort);
print LOGG "\$el = $el at sub el_tryck etter 4. if\n" if $logg;
	}

#print LOGG "\$el = $el at sub el_tryck etter tredje if\n" if $logg;
#		if ($el =~ /$suffiks$/) {			#om det slutar p betonbart suffix (-het)
#print LOGG "\$el = $el at sub el_tryck etter fjerde if\n" if $logg;
#			$el = &stress_suffix($el,$el_ort);	#flytter trykk til hyre (til -het)
#		} else { 
#print LOGG "\$el = $el at sub el_tryck etter frste else\n" if $logg;
#		}

	 else {
print LOGG "\$el = $el at sub el_tryck etter 1. else\n" if $logg;

#	} elsif ($el =~ /$tonem2/ && $el !~ /$bitrykk/) {		#$el har grav betoning, bitryck r ej utsatt	
#orig	} elsif ($el =~ /$tonem2/ && $el !~ /$bitrykk/) {		#$el har grav betoning, bitryck r ej utsatt	

		if ($el =~ /^($prefiks)/) {	#om det brjar p betonbart prefix + stavelsegrns, trykk flyttes til 
#orig		if ($el =~ /^($prefiks)\./ && $el !~ /$endings$/) {	#om det brjar p betonbart prefix + stavelsegrns, trykk flyttes til 
print LOGG "\$el = $el at sub el_tryck etter 5. if\n" if $logg;
			$el = &stress_right($el,$el_ort);

		} elsif ($el =~ /$suffiks$/) {			#om det slutar p betonbart suffix (-het)
print LOGG "\$el = $el at sub el_tryck etter 6. if\n" if $logg;

			$el = &stress_suffix($el,$el_ort);
		} elsif ($el =~ /$special_word$/) {		#speciella ord, bitryck p andra stavelsen
print LOGG "\$el = $el at sub el_tryck etter 7. if\n" if $logg;
			$el = &stress_second($el,$el_ort);
		} elsif ($el =~ /$word_last$/) {
print LOGG "\$el = $el at sub el_tryck etter 8. if\n" if $logg;
			$el = &stress_last($el,$el_ort);	
		} else {
print LOGG "\$el = $el at sub el_tryck etter 2. else\n" if $logg;
			$el = &stress_main($el,$el_ort);
		}
	}

print LOGG "\$el = $el at sub el_tryck end\n" if $logg;
	$el =~ s/<BITRYCK>/$bitrykk/;
	return $el;
} #end sub

#**********************************************************************************************************
#subbar som flyttar efterledens betoning

#flyttar bitrycket till det betonbara suffixet
sub stress_suffix {
	my ($el,$el_ort) = @_;
print LOGG "\nSubroutine stress_suffix\n" if $logg;
print LOGG "\$el = $el at sub stress_suffix start\n" if $logg;
	$el =~ s/[$bitrykk]//g;
	$el =~ s/(.*)\.($suffiks)$/$1\.<BITRYCK>$2/;
	$el = &change_e($el,$el_ort);
print LOGG "\$el = $el at sub stress_suffix end\n" if $logg;
	return $el;
	}

#flyttar bitrycket en stavelse till hger om huvudtrycket
sub stress_right {
	my ($el,$el_ort) = @_;
print LOGG "\nSubroutine stress_right\n" if $logg;
print LOGG "\$el = $el at sub stress_right start\n" if $logg;
	$el =~ s/$bitrykk//;

	$el =~ s/^(2)?\'([$tkn]*)\.(.*)/$2\.<BITRYCK>$3/;	#changed 13/2 flytter trykk til hyre
#orig	$el =~ s/^2\'([$tkn]*)\.(.*)/$1\.<BITRYCK>$2/;	#changed 13/2 flytter trykk til hyre


	$el =~ s/$tonem2//;
	$el = &change_e($el,$el_ort);
print LOGG "\$el = $el at sub stress_right end\n" if $logg;
	return $el;
	}

#flyttar bitrycket till sista stavelsen
sub stress_last {		
	my ($el,$el_ort) = @_;
print LOGG "\nSubroutine stress_last\n" if $logg;
print LOGG "\$el = $el at sub stress_last start\n" if $logg;
	$el =~ s/$tonem2//g;
	$el =~ s/(.*)\.(.*)/$1\.<BITRYCK>$2/;
	$el = &change_e($el,$el_ort);
print LOGG "\$el = $el at sub stress_last end\n" if $logg;
	return $el;
	}

#flyttar bitrycket till andra stavelsen i ordet
sub stress_second {
	my ($el,$el_ort) = @_;
print LOGG "\nSubroutine stress_second\n" if $logg;
print LOGG "\$el = $el at sub stress_second start\n" if $logg;
	$el =~ s/[$bitrykk]//g;	
	$el =~ s/([$tkn])\.(.*)/$1\.<BITRYCK>$2/;
	$el = &change_e($el,$el_ort);
print LOGG "\$el = $el at sub stress_second end\n" if $logg;
	return $el;
	}

#gr huvudtryck till bitryck
sub stress_main {
	my $el = shift;
print LOGG "\nSubroutine stress_main\n" if $logg;
print LOGG "\$el = $el at sub stress_main start\n" if $logg;
	$el =~ s/($tonem2|$tonem1)/<BITRYCK>/;
	return $el;
print LOGG "\$el = $el at sub stress_main end\n" if $logg;
	}					

#tar bort huvudtrycket, bitrycket behlls
sub stress_remove_main {
	my ($el,$el_ort) = @_;
print LOGG "\nSubroutine stress_remove_main\n" if $logg;
print LOGG "\$el = $el at sub stress_remove_main start\n" if $logg;
	$el =~ s/$tonem2//;
	$el = &change_e($el,$el_ort);
print LOGG "\$el = $el at sub stress_remove_main end\n" if $logg;
	return $el;
}

#sista ledet har akut betoning
sub stress_toneme1 {
	my $el = shift;
print LOGG "\nSubroutine stress_toneme1\n" if $logg;
print LOGG "\$el = $el at sub stress_toneme1 start\n" if $logg;
	$el =~ s/$tonem2/\'/;
print LOGG "\$el = $el at sub stress_toneme1 end\n" if $logg;
	return $el;
}

#changed 27/2
#ndrar E till e om  inte finns i ortografin och om huvudtrycket frsvinner sedan
#specifically swedish - references to this one should be removed
sub change_e {				#changed 14/2
	my ($el,$el_ort) = @_;
	if ($el_ort !~ /(r|(s|t|d|n|l)\+)/ && $el =~ /(^|$del)[$tkn_no_stress]*E(r|(s|t|d|n|l)\+)/) {
		$el =~ s/^(.*$del?[^$bitrykk][$tkn_no_stress]*)E([r(s|t|d|n|l)\+].*)/$1e$2/;
		}
	return $el;
	}

	
#********************* RETROFLEXERING AV FRLED OCH MELLANLED **********************
#Endret SE
sub fl_retroflex {
	my $fl = shift;
print LOGG "\nSubroutine fl_retroflex\n" if $logg;
print LOGG "\$fl = $fl at sub fl_retroflex start\n" if $logg;

	$fl =~ s/(t|d|l|n)(\+)(t|d|l|n)$/$1$2$3\+/; 
	$fl =~ s/S(t|d|l|n)$/S$1\+/; 

	$fl =~ s/r(t|d|l|n)$/$1\+/;
	$fl =~ s/rs$/S/;

#Svensk original:
#	$fl =~ s/(s|t|d|l|n)(\+)(s|t|d|l|n)$/$1$2$3\+/; 
#	$fl =~ s/r(s|t|d|l|n)$/$1\+/;

print LOGG "\$fl = $fl at sub fl_retroflex end\n" if $logg;
	return ($fl);
	}

#**************************************************************************************************
sub fl_special {

#endret til norsk
	my $fl = shift;
print LOGG "\nSubroutine fl_special\n" if $logg;
print LOGG "\$fl = $fl at sub fl_special start\n" if $logg;
	$fl =~ s/2\'r6i:ks/2\'r6Iks/;
#	$fl =~ s/2\'dA:gs/2\'dAks/;	#no devoicing in Norwegian
	$fl =~ s/(stA:ds|stA:ts)/stAts/;
#	$fl =~ s/sku:gs/skUks/;
#	$fl =~ s/kr6i:gs/kr6Iks/;
#	$fl =~ s/str6i:ds/str6Its/;
#	$fl =~ s/li:Vs/lIfs/;
#	$fl =~ s/de\+:ds/de+ts/;
	$fl =~ s/ri:ks/rIks/;
	
#	$fl =~ s/2\'al\.kU\.ho:l/al\.kU\.2\'ho:l/;
#	$fl =~ s/fe\+\.ru0:t/2\'fe\+:\.ru0:t/;
print LOGG "\$fl = $fl at sub fl_special end\n" if $logg;
	return $fl;
}

sub el_special {
#gjr ingenting n
	my $el = shift;
print LOGG "\nSubroutine el_special\n" if $logg;
print LOGG "\$el = $el at sub el_special start\n" if $logg;
print LOGG "\$el = $el at sub el_special end\n" if $logg;
	return $el;
}

#************************** DEVOICE ********************************************
#this may well overgenerate, since devoicing should not (always) occur in  Norwegian
sub devoice {
my $fl = shift;
print LOGG "\nSubroutine devoice\n" if $logg;
print LOGG "\$fl = $fl at sub devoice start\n" if $logg;
	$fl =~ s/($shortvowel)(b|d|g|V|v)(s|t)/$1$devoice{$3}$4/;
print LOGG "\$fl = $fl at sub devoice end\n" if $logg;
	return $fl;
} #end sub

#************************** SPECIAL LMCCs ********************************************
#changed 27/2
sub special_lmcc {
	my $fl = shift;
print LOGG "\nSubroutine special_lmcc\n" if $logg;
print LOGG "\$fl = $fl at sub special_lmcc start\n" if $logg;
	if (exists ($special_lmcc{$fl})) {
		$fl =~ s/$fl/$special_lmcc{$fl}/;
		}
print LOGG "\$fl = $fl at sub special_lmcc end\n" if $logg;
	return $fl;
} #end sub

#*************************************** RETROFLEXERING ****************************************************
sub retr {
	my ($fl,$el) = @_;
print LOGG "\nSubroutine retr\n" if $logg;
print LOGG "\$fl = $fl at sub retr start\n" if $logg;
print LOGG "\$el = $el at sub retr start\n" if $logg;
	my ($new_fl,$new_el_start,$new_el_rest);
	my $cmptemp = $fl."<SKARV>".$el;
	if ($cmptemp =~ /^(.*)r<SKARV>([\'\"\.2]*[sndtl])([^\+].*)$/) {
		$new_fl = $1;
		$new_el_start = $2;
		$new_el_rest = $3;
		unless (&no_retr_flag($fl,$el)) {
			$fl =~ s/r$//;
			$el =~ s/^([^sndtl]*?[sndtl])/$1\+/;
		} else {
			$el =~ s/^([^sndtl]*?[ndtl])/$1\+/;
			}
	} # end if
	
	($fl,$el) = &retr_trans($fl,$el);
print LOGG "\$fl = $fl at sub retr end\n" if $logg;
print LOGG "\$el = $el at sub retr end\n" if $logg;
	return ($fl,$el);
} # end sub

sub no_retr_flag {
	my ($fl,$el) = @_;
print LOGG "\nSubroutine no_retr_flag\n" if $logg;
print LOGG "\$fl = $fl at sub no_retr_flag start\n" if $logg;
print LOGG "\$el = $el at sub no_retr_flag start\n" if $logg;
	my $cmptemp = $fl."<SKARV>".$el;
	my $last_fl_syll = (split /\./,$fl)[-1];
	my $stress_on_last_syll = $last_fl_syll =~ s/\'/\'/g;
	my $r_after_short_vowel = $last_fl_syll =~ s/([^\:])r$/\$1r/g;
	my $no_retr_flag = 0;
	$no_retr_flag = 1 if ($stress_on_last_syll && $r_after_short_vowel);
print LOGG "\$fl = $fl at sub no_retr_flag end\n" if $logg;
print LOGG "\$el = $el at sub no_retr_flag end\n" if $logg;
	return $no_retr_flag;
}

sub retr_trans {
	my ($fl,$el) = @_;
print LOGG "\nSubroutine retr_trans\n" if $logg;
print LOGG "\$fl = $fl at sub retr_trans start\n" if $logg;
print LOGG "\$el = $el at sub retr_trans start\n" if $logg;

#Denne subrutinen er kommentert bort, da vi for norsk ikke foretar retrofleksering p tvers av ordgrenser (GA 26/5-01)

#	if ($fl =~ /([ndtl]\+)|(S)$/) {
#		if ($el =~ /^[\'\"\.2]*[sndtl][^\+]/) {
#			$el =~ s/^([\'\"\.2]*[sndtl])([^\+])/$1\+$2/;
#		}
#	}
#	if ($el =~ /^[\'\"\.2]*[sndtl][\+][sndtl][^\+]/) {
#		$el =~ s/^([\'\"\.2]*[sndtl][\+][sndtl])([^\+])/$1\+$2/;
#	}
#	if ($el =~ /^[\'\"\.2]*[sndtl][\+][sndtl][^\+]/) {
#		$el =~ s/^([\'\"\.2]*[sndtl][\+][sndtl])([^\+])/$1\+$2/;
#	}
#	if ($el =~ /^[\'\"\.2]*[sndtl][\+][sndtl][^\+]/) {
#		$el =~ s/^([\'\"\.2]*[sndtl][\+][sndtl])([^\+])/$1\+$2/;
#	}
print LOGG "\$fl = $fl at sub retr_trans end\n" if $logg;
print LOGG "\$el = $el at sub retr_trans end\n" if $logg;
	return ($fl,$el);
} # end sub

#****************************************** VELARISERING ********************************************
sub velarisering {
	my ($fl,$el) = @_;
print LOGG "\nSubroutine velarisering\n" if $logg;
print LOGG "\$fl = $fl at sub velarisering start\n" if $logg;
print LOGG "\$el = $el at sub velarisering start\n" if $logg;
	my $cmptemp = $fl."<SKARV>".$el;
	$cmptemp =~ s/([^m])n(<SKARV>[\'\"\.2]*[gk])/$1nK$2/;
	($fl,$el) = split "<SKARV>",$cmptemp;
print LOGG "\$fl = $fl at sub velarisering end\n" if $logg;
print LOGG "\$el = $el at sub velarisering end\n" if $logg;
	return ($fl,$el);
} # end sub

#********************************** SYLLABIFY *****************************************
sub lasse_syllabify {
	my ($listel,$outel,$ret,$indexstring,$untouched,$touched);
	my $wd = shift;
	
	my $index = q/|||||\#|/;
	# temporarily remove indexes
	if ($wd =~ /^(.+?)(($index)*)$/) {
		$indexstring = $2;
		$wd = $1;
	}
	else {$indexstring = "";}
		
	# get the part to syllabify
	my @sylls = split /\./,$wd;
	
		$touched = $wd;
			
	my $prelhs = &x_ify_lh($touched);
	my $lhs = $prelhs;
	my @lhs_list = split /x530/,$lhs;
	my @syllabified = ();
	foreach $listel (@lhs_list) {
		push @syllabified,&syllabify($listel);
	} # end foreach

	my $syllabified = join "x530",@syllabified;
	$syllabified =~ s/^x//;
	my @out = split /x/,$syllabified;
	my $convertedstring = "";
	
	foreach $outel (@out) {
		if (exists $map{$outel}) {$convertedstring .= $map{$outel};}
		else {	
			print OUT "SYMBOL ERROR $outel in $wd\n";
			return $ret
		} # end else
	}
	
	# Ugly fix to avoid syllabification in word boundaries
	$convertedstring =~ s/([\_\"]+)\./$1/g;
	my $outstring = "$convertedstring";
	$newtrk = $outstring.$indexstring;
	return $newtrk;

} # end sub


#From Norwegian ScandInflect
sub x_ify_lh {

	my $ttt = shift;

	$ttt =~ s/E\&U0/x151/g;	#OK	diftong au
	$ttt =~ s/E\+\&Y/x153/g;	#OK	diftong y
	$ttt =~ s/E\&I/x152/g;	#OK	diftong ei
	$ttt =~ s/n\+%\)/x930/g;	#	stavelsesbrende konsonant n+
	$ttt =~ s/l\+%\)/x940/g;	#	stavelsesbrende konsonant l+
	$ttt =~ s/A\&I/x154/g;	#OK	diftong ai
	$ttt =~ s/O\&I/x155/g;	#OK	diftong oi
	$ttt =~ s/t\&S/x190/g;	#	ustemt affrikat tsjekkia
	$ttt =~ s/n%\)/x910/g;	#	stavelsesbrende konsonant n
	$ttt =~ s/l%\)/x920/g;	#	stavelsesbrende konsonant l
	$ttt =~ s/u0:/x050/g;	#OK	lang vokal u
	$ttt =~ s/e\+:/x090/g;	#OK	lang vokal 
	$ttt =~ s/A:/x010/g;	#OK	lang vokal a
	$ttt =~ s/e:/x020/g;	#OK	lang vokal e
	$ttt =~ s/i:/x030/g;	#OK	lang vokal i
	$ttt =~ s/u:/x040/g;	#OK	lang vokal o
	$ttt =~ s/y:/x060/g;	#OK	lang vokal y
	$ttt =~ s/o:/x070/g;	#OK	lang vokal 
	$ttt =~ s/\@:/x081/g;	#OK	lang vokal 
	$ttt =~ s/U0/x221/g;	#OK	kort vokal u
	$ttt =~ s/E\+/x091/g;	#OK	kort vokal 
	$ttt =~ s/d\+/x100/g;	#OK	retrofleks d
	$ttt =~ s/t\+/x110/g;	#OK	retrofleks t
	$ttt =~ s/n\+/x130/g;	#OK	retrofleks nasal
	$ttt =~ s/l\+/x140/g;	#OK	retrofleks lateral
	$ttt =~ s/nK/x400/g;	#OK	velar nasal
	$ttt =~ s/r6/x421/g;	#OK	alveolar flap
	$ttt =~ s/2\'/x510/g;	#OK	tonem 2
	$ttt =~ s/\'2/x520/g;	#OK	bitrykk
	$ttt =~ s/A/x181/g;	#OK	kort vokal a
	$ttt =~ s/I/x200/g;	#OK	kort vokal i
	$ttt =~ s/U/x210/g;	#OK	kort vokal u
	$ttt =~ s/Y/x230/g;	#OK	kort vokal y
	$ttt =~ s/O/x240/g;	#OK	kort vokal 
	$ttt =~ s/E/x250/g;	#OK	kort vokal e
	$ttt =~ s/b/x270/g;	#OK	b
	$ttt =~ s/d/x280/g;	#OK	d
	$ttt =~ s/g/x290/g;	#OK	g
	$ttt =~ s/p/x300/g;	#OK	p
	$ttt =~ s/t/x310/g;	#OK	t
	$ttt =~ s/k/x320/g;	#OK	k
	$ttt =~ s/f/x330/g;	#OK	f
	$ttt =~ s/s/x340/g;	#OK	s
	$ttt =~ s/S/x341/g;	#OK	sj
	$ttt =~ s/V/x360/g;	#OK	v
	$ttt =~ s/C/x370/g;	#OK	kj
	$ttt =~ s/m/x380/g;	#OK	m
	$ttt =~ s/n/x390/g;	#OK	n
	$ttt =~ s/l/x410/g;	#OK	l
	$ttt =~ s/h/x430/g;	#OK	h
	$ttt =~ s/j/x440/g;	#OK	j
	$ttt =~ s/\'/x500/g;	#OK	hovedtrykk
	$ttt =~ s/\./x530/g;	#OK	stavelsesgrense
	$ttt =~ s/\_/x550/g;	#OK	underscore
	$ttt =~ s/\"/x570/g;	#OK	fraseaksent

	$t->insert("end","xify returns:   $ttt\n") if $winlog;
	return $ttt;

} # end sub


#From Norwegian ScandInflect
sub syllabify {


	my $ilstring = shift;
	my $voc_pattern = "(x010|x020|x030|x040|x050|x060|x070|x081|x090|x091|x151|x152|x153|x154|x155|x181|x200|x210|x221|x230|x240|x250|x910|x920|x930|x940)";
	my $stress_pattern = "(x500|x510|x520|x570|)";
	my $syll_pattern = "x530";

	my $onset_pattern = join "|",@il_onsets;
	$onset_pattern =~ s/^(.*)$/\($1|\)/;

	my $ret = "";

	while ($ilstring =~ s/^((.*?)($stress_pattern)($onset_pattern)($voc_pattern))//) {
		$ret .= "$2$syll_pattern$3$5$7";
	}

	$ret .= $ilstring;
	$ret =~ s/^$syll_pattern//;
	
	$ret = fix_corrupt_syll($ret);
	return $ret;

} # end sub




sub retroflex_transform {
	my $xstring = shift;
	my $n;
	#print STDOUT "$xstring\n";
	
	if ($xstring =~ /^(.*)(x010|x020|x030|x040|x050|x060|x070|x080|x090)r((x500|x510|x520|x530)*)(x280|x310|x340|x390)(.*)$/) {
		if ($5 eq "x280") {$n = "x100"}
		elsif ($5 eq "x310") {$n = "x110"}
		elsif ($5 eq "x340") {$n = "x120"}
		elsif ($5 eq "x390") {$n = "x130"}
		$xstring = $1.$2.$3.$n.$6;
	}

	foreach (0..4) {
	if ($xstring =~ m/^(.*)(x100|x110|x120|x130)((x500|x510|x520|x530)*)(x280|x310|x340|x390)(.*)$/) {
		if ($5 eq "x280") {$n = "x100"}
		elsif ($5 eq "x310") {$n = "x110"}
		elsif ($5 eq "x340") {$n = "x120"}
		elsif ($5 eq "x390") {$n = "x130"}
		$xstring = $1.$2.$3.$n.$6;
	}
	}
	
	my $ret = $xstring;
	return $ret
	
} #end sub


#From Norwegian ScandInflect
# Fix that takes care of unusual initial clusters such as ts, ps and so on that are not legal onsets but exists
# appends syllables with no vowel with the syllable that follows 
sub fix_corrupt_syll {
	my $ret = shift;
	my $newret = "";
	my @newsylls = ();
	my $deletetag = "TABORT";
	my @sylls = split /x530/,$ret;
	my $voc_pattern = "(x010|x020|x030|x040|x050|x060|x070|x081|x090|x091|x151|x152|x153|x154|x155|x181|x200|x210|x221|x230|x240|x250|x910|x920|x930|x940)";
	foreach $s (@sylls) {
		unless ($s =~ /$voc_pattern/) {
			$s = $s.$deletetag;
		} # end unless
		push @newsylls,$s;
	}
	$newret = join "x530",@newsylls;
#	print LOG "NEWRET BEFORE: $newret\n" if $printlog;	
	$newret =~ s/TABORTx530//g;
#	print LOG "NEWRET AFTER: $newret\n" if $printlog;
	return $newret;
} # end sub
