#!perl -w

##########################################################################
#	recompounder_lh.pl
#	Skaper transkripsjoner av en dekomponert sammensetning (vare+bil)
#	For-/mellomledet sls opp i fl.LEX
#	Etterledet sls upp i simplex.txt.
#	Dette er den norske verjonen av ordsammensetteren. 
#	220501: GA
###########################################################################

#############################LOGGSKRIVING#################################
#maskinspecifika pather stts hr
#$RECOMP     = 'W:/LEX_NO/frekvens_no';
#$LEXICAS    = 'W:/LEX_NO/CD_GISLE_AUG01/shared/shared/Recompounder/Leksikon/';
$LEXICAS    = './RECOMP_LEKSIKON/';
#$CURRENT    = $RECOMP.'run/';
###########################################################################


#############################LOGGSKRIVING#################################
#input filer specificeras hr
open LEX,$LEXICAS."simplex.txt";
open FLLEX,$LEXICAS."fl_lh_no.LEX";
open TNM,$LEXICAS."block_tnm_ch.lex";
###########################################################################



%devoice = ("b","p","d","t","g","k","V","f");
%special_lmcc =  ("2\'r6i:ks","2\'r6Iks","r6i:ks","r6Iks");
$shortvowel = "(A|E|I|U|U0|Y|E+|O)";
$prefiks = '2\'Al|\'An.tI|2?\'AnK|2?\'An|2?\'A:V|(2)?\'bi:|(2)?\'bUt\+|\'Ci:.lU|2\'de:l|\'de:\.sI|\'di:t|2\'E\.tEr6|2\'e:n |2\'e:r6|\'Eks|2\'Ek\.str6A|\'fAst|2\'fle:r6|'.
	'2\'fUt+|2\'fe\+:r6|2\'fo:\.r6E|\'fO\.r6U0|2?\'gu:|2?\'jEn|2\'jE\.nOm|2?\'hE\.?\'?2?n|2\'hi:t|\'hy:.pEr6|'.
	'2\'I\.kE|2\'InK|2?\'In|\'kOn\.tr6A|2\'V@:r6|\'kVA:\.sI|\'mA:\.kr6U|\'mA.kr6U|\'mAk\.sI|2?\'me:\.?d|\'mI\.dEl|'.
	'2\'mE\.lOm|\'mi:\.dI|\'mI\.lI|\'mi:\.kr6U|\'mI\.kr6U|\'mi:\.nI|2\'mIs|2?\'mu:t|\'mU0l\.tI|2\'mAnK|\'ne:d|'.
	'\'ne:\.U|2?\'Om|\'pr6u:|\'p?sE\&U0.dU|\'p?sE\&U0.dO|\'p?sEV.dU|\'p?sEV.dO|2?\'po:|2\'sAm|\'se:\.mI|\'sEn\.tI|\'su0:\.pEr6|'.
	'2\'s@:r6|2?\'tI\.?\'?2?l|\'tr6I\.pEl|2\'tu:|2\'tVe:|\'U0l\.tr6A|2\'Um|2?\'U0n|2\'U0n\.dEr6|2\'U0\.nEr6|'.
	'2?\'O\.?\'?2?p|2\'u0:r6|2?\'u0:\.?\'?2?t|2\'VAnK|2\'VAn|2\'V@:r6|2\'Vi:\.sE|2\'Vi:\.dE.r6E|2\'Er6\.kE|2\'o:\.VEr6';
$suffiks = '((s|S)?mo:\.?l(E|Et|A|E\.nE|ln\%\)\.E)?)s?|(pUnKk\.?t(Er6|E|E\.nE|n\%\)\.E)?)s?|((s|t)(i:|I)\.?V(En|Et|Er6|E|t|E\.nE)?)s?|((s|S)kA:\.?p(En|Et|ES|A|Er6|E|E\.nE)?)s?|skA:\.p(E\.)?lI(\.E)?s?|((h|t)e:\.?t(En|n%\)|n%\)\.E|Er6|E\.nE)?)s?';
$weekday = '(mAn|t(i:|I)S|Uns|t(o:|u:|U)S|fr6e:|le\+:|sE\+n)\.(\'2)?(d\+?A:\.?g(En|Er6|E\.nE)?)s?';
$directions = '(\'2(VEst\.lI|E\+st\.lI|E\&U0st\.lI|SYl\.dI|dr6Ek\.tI|VE\.d\+I|sIn\.dI)E?s?)|(\'2(E\+st|E\&U0st|VEst))(s?|(En)?s?)|\'2E\+\.stn\%\)s?|\'2VE\.stn\%\)s?|\'2E\&U0\.stn\%\)s?';
$special_word = '####';
$word_last = 'i:\.dr6Et|bO&I\.kOt';
$change_tonem = 'gjennom|mellom|over|sammen|pepper|under|vinter';
$tkn = "a-z A-Z 02\'\&\%\)6:\+";
$tonem1 = "\'";
$tonem2 = "2\'";
$bitrykk = "\'2";

@il_onsets = qw(
x340x300x421
x340x300x410
x340x300x440
x340x310x421
x340x310x440
x340x320x360
x340x320x421
x340x320x410
x300x421
x300x410
x300x440
x270x421
x270x410
x270x440
x310x421
x310x360
x310x440
x280x360
x280x440
x280x421
x320x390
x320x360
x320x421
x320x410
x290x390
x290x421
x290x410
x380x440
x390x440
x330x390
x330x421
x330x410
x330x440
x360x421
x340x300
x340x310
x340x320
x340x380
x340x390
x340x330
x340x360
x340x410
x341x310
x341x320
x341x410
x300
x270
x310
x280
x320
x290
x380
x390
x330
x360
x421
x340
x341
x370
x430
x410
x440
x100
x110
x130
x140
x190
);

#******************************************* LEKSIKON *********************************************
#alle simpleksord i stora norska leksikonet
while (<LEX>) {
	chomp;
	@lexline = split /\;/;
	$lexort = $lexline[1];	#$lexort =~ s/\#.*//;
	$lextrk = $lexline[11];
	$lexpos = $lexline[3];
	$lexcode = $lexline[7];
	$lexinfo = $lexline[27]; #if ($lexinfo !~ /[a-z]/) { $lexinfo = "no_teliainfo"; }
	$lexid = $lexline[40];
		
	$lex{$lexort} = "$lexcode--$lexort--$lextrk--$lexpos--$lexinfo--$lexid";	
}
print "Ferdig med lesning av simpleks-leksikon...\n";

#*****************************************FL-LEKSIKON *********************************************
#norsk forleddsleksikon
while (<FLLEX>) {
	chomp;
	($code,$fl,$trk,$lemma_ort,$lemma_trk,$pos,$info,$id) = split /\t/;
	$fl{$fl} = "$code--$fl--$trk--$lemma_ort--$lemma_trk--$pos--$info--$id";
}
print "Ferdig med lesning av forleddsleksikon...\n";

#*****************************************UNNTAKSLEKSIKON *********************************************
#unntaksleksikon for  blokkere tonemendring
while (<TNM>) {
	chomp;
	@stuff = split /\t/, $_;
	$word = $stuff[0];
	$tnm{$word} = $word;
}
print "Ferdig med lesning av unntaksleksikon...\n";
#***************************************** SLUT INLSNING *********************************************


#$decomp = 'spesial+sfrenn+Vest+breddens';
#$recomp = &recompound($decomp);
#print "\nRECOMP = $recomp\n";
#sleep 1000;








sub recompound {
	$s_fix = 0;

	@fl_code = ();
	@fl_ort = ();
	@fl_trk = ();
	@el_code = ();
	@el_ort = ();
	@el_trk = ();
	@dec_lookup = (); 
	@ml = ();
	@sms_trk = ();
	@ml = (); 
	@codes = (); 
	@orts = (); 
	@trks = ();
	$lemma_ort = ""; 
	$lemma_trk = ""; 
	$trks = ""; 
	$orts = "";
	
	chomp;
	$dec = shift;
	$orig_ort = $dec;
	$orig_ort =~ s/[\+\!\*]//g;
	$orig_dec = $dec;

	$dec =~ s/\+s\+/s\+/g;
	$dec =~ s/\+e\+/e\+/g;

	@dec = split /\+/,$dec;
	
	$el_ort = pop @dec;		#etterledet
	$el = &lookup($el_ort);	#slr opp i simplex-lexikon

	if ($el =~ /not_in_lex/) {	#prver  lowercase etterleddet for  se om den finner det da
		$el1 = $el_ort;
		$el1 =~ s/^//;
		$el1 =~ s/^//;
		$el1 =~ s/^//;
		$el1 = lcfirst $el1;
		$el = &lookup($el1);	#slr opp i simplex-lexikon
	}

	if ($el =~ /not_in_lex/) {	#prver  fjerne final -s i genitiver for  se om den finner det da
		$el2 = $el_ort;
		$el2 =~ s/s$//;
		$el = &lookup($el2);	#slr opp i simplex-lexikon
		$s_fix = 1 if (($el !~ /not_in_lex/) && ($orig_dec =~ /s$/));
	}
	
	#Tar hnd om eventuelle simpleksord i dekomponeringsfilen
	if ($dec !~ /\+/) {
		@simpl = split /--/,$el;
		$trans = $simpl[2];
		$trans = "$trans"."s" if $s_fix;
		$trans =~ s/not_in_lex//;
		return $trans;
	}

	($lemma_ort,$lemma_trk,@fl) = &fl_lookup(@dec);	#allt utom sista sls upp i fl-lexikon - finner lemmat

#***************************** FIKSE ETTERLEDD ****************************************
	@el = split /--/,$el;					#@el = kod,ort,trk
	
	($lemma_ort,$lemma_trk,$el_code,$el_ort,$el_trk) = &prepare_el($lemma_ort,$lemma_trk,@el);	#gr iordning efterledet
	$el_code =~ s/(.*);c.*/$1/;					#bara ordklasskoden ska vara kvar
	
#***************************** FIKSE FORLEDD OG MELLOMLEDD ***************************
	$antal = 0;					#skickas med fr att se om det r fl eller ml

	foreach $fl (@fl) {				#frled + mellanled
		($fl_code,$fl_ort,$fl_trk) = split /--/,$fl;
		if (($fl_trk !~ /\./) && ($el_trk =~ /^$directions$/)) {
			($fl_trk,$el_trk) = &special_trks($fl_trk,$el_trk);
		}
		elsif ($antal == 0) {				#frled
			$fl_trk = &fl_tryck($fl_trk,$fl_ort);		#betoning
		} else {					#mellanled
			$fl_trk = &ml_tryck($fl_trk);		#betoning
		}
		push @codes,$fl_code;
		push @orts,$fl_ort;
		push @trks,$fl_trk;
		$antal++;	
	}

#***************************** FIKSE ETTERLEDD CTD ****************************************
	push @codes,$el_code;
	push @orts,$el_ort;
	push @trks,$el_trk;

	$codes = join "-",@codes;
	$orts = join "\+",@orts;
	$trks = join "\-",@trks;

	$trks = &phonology($trks);

	$trks =~ s/not_in_lex//g;
	$trks = "$trks"."s" if $s_fix;

	return $trks;

} #end sub








#******************************** SPECIAL TRKS ***********************************
sub special_trks {						#added 13/2
#NOT IN USE FOR NORWEGIAN
	my ($fl_trk,$el_trk) = @_;
	$fl_trk =~ s/\'//;
	$el_trk =~ s/\'2/\'/;
	return ($fl_trk,$el_trk);
} #end sub

#******************************** FONOLOGISKA PROCESSER ***********************************
sub phonology {
	my $sms_trk = shift;

#print LOGG "\nSubroutine phonology\n" if $logg;
#print LOGG "\$sms_trk = $sms_trk at sub phonology start\n" if $logg;

	my ($i,$j,$fl,$el);
	@sms_trk = split /-/,$sms_trk;

	$i = 0;
	$j = 1;

	for ($i = 0; $i < $#sms_trk; $i++) {
		$j = $i + 1;
		($fl,$el) = &retr($sms_trk[$i],$sms_trk[$j]);	#retroflection
	#	($fl,$el) = &velarisering($fl,$el);		#velarising
	#	$fl = &devoice($fl);				#devoicing
	#	$fl = &special_lmcc($fl);			#special
		$sms_trk[$i] = $fl; 
		$sms_trk[$j] = $el;
	}

	$sms_trk = join "\.",@sms_trk;

#print LOGG "\$sms_trk = $sms_trk at sub phonology end\n\n" if $logg;

return $sms_trk;

} #end sub
	
#******************************************** LOOKUP *********************************************
#endast fr efterledet
sub lookup {
#"numeral","noun","adverb","adj","verb","prepostition","interjection","conjunction";
	
		my $el = shift;
		my $lexstuff;
		if (exists ($lex{$el})) {
			$lexstuff = $lex{$el};
		} else {
			$lexstuff = "not_in_lex--not_in_lex--not_in_lex--not_in_lex--not_in_lex--not_in_lex";
		}
		return $lexstuff;
} #end sub

#**************************************** FL_LOOKUP *********************************************
sub fl_lookup {
	my @dec = @_;
	my ($part,$lexstuff,$lemma_ort,$lemma_trk,@lemma_ort,@lemma_trk);

	foreach $part (@dec) { 
		if (exists ($fl{$part})) {
			$lexstuff = $fl{$part};
			push @dec_lookup,$lexstuff;
			@lexstuff = split /--/,$lexstuff;
			push @lemma_ort,$lexstuff[3];
			push @lemma_trk,$lexstuff[4];
			$lemma_ort = join "\+",@lemma_ort;
			$lemma_trk = join "--",@lemma_trk;
		} else {
			$lexstuff = "not_in_lex--not_in_lex--not_in_lex--not_in_lex--not_in_lex--not_in_lex";
			push @dec_lookup,$lexstuff;
		}
	}
	return $lemma_ort,$lemma_trk,@dec_lookup;		
} #end sub

#******************************************** ETTERLED *********************************************
sub prepare_el {
	my ($lemma_ort,$lemma_trk,$code,$ort,$trk,$pos,$info,$id) = @_;
	$lemma_ort .= "+$ort";
	$lemma_trk .= "--$trk";
	$trk = &el_tryck($trk,$ort);						#betoning
	return $lemma_ort,$lemma_trk,$code,$ort,$trk;	
} #end sub

#************************************** BETONING *****************************************************		
sub fl_tryck {
	# Endrer hovedtrykk til tonem 2 i visse tilfeller
	# og fjerner bitrykk fra forleddet

	my ($fl,$ort) = @_;

#print LOGG "\$fl = $fl at sub fl_tryck start\n" if $logg;
#print LOGG "\$ort = $ort at sub fl_tryck start\n" if $logg;

	if (($ort =~ /^$change_tonem$/) or (($fl !~ /\./) and not (exists ($tnm{$ort})))) {
		$fl =~ s/$tonem2/<TRYKK>/;
		$fl =~ s/$tonem1([^2])/<TRYKK>$1/;
		$fl =~ s/$bitrykk//g;
		$fl =~ s/<TRYKK>/$tonem2/;
	}

	else {
		$fl =~ s/$bitrykk//g;
	}

#print LOGG "\$fl = $fl at sub fl_tryck end\n" if $logg;

	return $fl;

} # end sub

sub ml_tryck {
	#fjerner alle trykk fra mellomleddene
	#ok for norsk ogs, da ord skal maksimalt ha ett hovedtrykk og ett bitrykk
	my ($ml,$ort) = @_;
#print LOGG "\$ml = $ml at sub ml_tryck start\n" if $logg;
	unless ($ml =~ /^\'mA&I$/) {	#spesiell regel for syttende+mai+tale
		$ml =~ s/[$tonem2]//g;
	}
#print LOGG "\$ml = $ml at sub ml_tryck end\n" if $logg;
	return $ml;
} #end sub


#changed 2/3
sub el_tryck {
	my ($el,$el_ort) = @_;
#print LOGG "\$el = $el at sub el_tryck start\n" if $logg;
	if ($el =~ /$weekday/) {				#om det brjar p betonbart prefix + stavelsegrns:
		$el = &stress_second($el,$el_ort);
	}
	elsif (($el =~ /$suffiks$/) && ($el !~ /^2?\'($suffiks)/)) {
		$el = &stress_suffix($el,$el_ort);	#flytter trykk til betonbart suffiks (til -het)
	} elsif ($el =~ /$tonem2.*$bitrykk/) {			#$el har bde huvud- och bitryck utsatt
		$el = &stress_remove_main($el,$el_ort);	
	} elsif ($el !~ /($tonem2|$bitrykk)/) { 				#$el har bara akut betoning
		$el = &stress_main($el,$el_ort);
	}
	 else {
		if ($el =~ /^($prefiks)/) {	#om det brjar p betonbart prefix + stavelsegrns, trykk flyttes til 
			$el = &stress_right($el,$el_ort);
		} elsif ($el =~ /$special_word$/) {		#speciella ord, bitryck p andra stavelsen
			$el = &stress_second($el,$el_ort);
		} elsif ($el =~ /$word_last$/) {
			$el = &stress_last($el,$el_ort);	
		} else {
			$el = &stress_main($el,$el_ort);
		}
	}
#print LOGG "\$el = $el at sub el_tryck end\n" if $logg;
	$el =~ s/<BITRYCK>/$bitrykk/;
	return $el;
} #end sub

#**********************************************************************************************************
#subbar som flyttar efterledens betoning

#flyttar bitrycket till det betonbara suffixet
sub stress_suffix {
	my ($el,$el_ort) = @_;
#print LOGG "\nSubroutine stress_suffix\n" if $logg;
	$el =~ s/[$bitrykk]//g;
	$el =~ s/(.*)\.($suffiks)$/$1\.<BITRYCK>$2/;
#print LOGG "\$el = $el at sub stress_suffix end\n" if $logg;
	return $el;
}

#flyttar bitrycket en stavelse till hger om huvudtrycket
sub stress_right {
	my ($el,$el_ort) = @_;
#print LOGG "\$el = $el at sub stress_right start\n" if $logg;
	$el =~ s/$bitrykk//;
	$el =~ s/^(2)?\'([$tkn]*)\.(.*)/$2\.<BITRYCK>$3/;	#changed 13/2 flytter trykk til hyre
	$el =~ s/$tonem2//;
#print LOGG "\$el = $el at sub stress_right end\n" if $logg;
	return $el;
}

#flyttar bitrycket till sista stavelsen
sub stress_last {		
	my ($el,$el_ort) = @_;
#print LOGG "\$el = $el at sub stress_last start\n" if $logg;
	$el =~ s/$tonem2//g;
	$el =~ s/(.*)\.(.*)/$1\.<BITRYCK>$2/;
#print LOGG "\$el = $el at sub stress_last end\n" if $logg;
	return $el;
}

#flyttar bitrycket till andra stavelsen i ordet
sub stress_second {
	my ($el,$el_ort) = @_;
#print LOGG "\$el = $el at sub stress_second start\n" if $logg;
	$el =~ s/[$bitrykk]//g;	
	$el =~ s/([$tkn])\.(.*)/$1\.<BITRYCK>$2/;
#print LOGG "\$el = $el at sub stress_second end\n" if $logg;
	return $el;
}

#gr huvudtryck till bitryck
sub stress_main {
	my $el = shift;
#print LOGG "\$el = $el at sub stress_main start\n" if $logg;
	$el =~ s/($tonem2|$tonem1)/<BITRYCK>/;
	return $el;
#print LOGG "\$el = $el at sub stress_main end\n" if $logg;
}					

#tar bort huvudtrycket, bitrycket behlls
sub stress_remove_main {
	my ($el,$el_ort) = @_;
#print LOGG "\$el = $el at sub stress_remove_main start\n" if $logg;
	$el =~ s/$tonem2//;
#print LOGG "\$el = $el at sub stress_remove_main end\n" if $logg;
	return $el;
}

#sista ledet har akut betoning
sub stress_toneme1 {
	my $el = shift;
#print LOGG "\$el = $el at sub stress_toneme1 start\n" if $logg;
	$el =~ s/$tonem2/\'/;
#print LOGG "\$el = $el at sub stress_toneme1 end\n" if $logg;
	return $el;
}

#**************************************************************************************************
sub fl_special {
	my $fl = shift;
#print LOGG "\$fl = $fl at sub fl_special start\n" if $logg;
	$fl =~ s/2\'r6i:ks/2\'r6Iks/;
	$fl =~ s/(stA:ds|stA:ts)/stAts/;
#print LOGG "\$fl = $fl at sub fl_special end\n" if $logg;
	return $fl;
}

sub el_special {
#gjr ingenting n
	my $el = shift;
#print LOGG "\$el = $el at sub el_special start\n" if $logg;
#print LOGG "\$el = $el at sub el_special end\n" if $logg;
	return $el;
}

#************************** DEVOICE ********************************************
#Not in use for  Norwegian
sub devoice {
my $fl = shift;
#print LOGG "\$fl = $fl at sub devoice start\n" if $logg;
	$fl =~ s/($shortvowel)(b|d|g|V|v)(s|t)/$1$devoice{$3}$4/;
#print LOGG "\$fl = $fl at sub devoice end\n" if $logg;
	return $fl;
} #end sub

#************************** SPECIAL LMCCs ********************************************
sub special_lmcc {
	my $fl = shift;
#print LOGG "\$fl = $fl at sub special_lmcc start\n" if $logg;
	if (exists ($special_lmcc{$fl})) {
		$fl =~ s/$fl/$special_lmcc{$fl}/;
	}
#print LOGG "\$fl = $fl at sub special_lmcc end\n" if $logg;
	return $fl;
} #end sub

#*************************************** RETROFLEKSERING ****************************************************
sub retr {
	my ($fl,$el) = @_;
#print LOGG "\$fl = $fl at sub retr start\n" if $logg;
#print LOGG "\$el = $el at sub retr start\n" if $logg;

#no retroflexation across component boundaries in Norwegian
#	my ($new_fl,$new_el_start,$new_el_rest);
#	my $cmptemp = $fl."<SKARV>".$el;
#	if ($cmptemp =~ /^(.*)r<SKARV>([\'\"\.2]*[sndtl])([^\+].*)$/) {
#		$new_fl = $1;
#		$new_el_start = $2;
#		$new_el_rest = $3;
#		unless (&no_retr_flag($fl,$el)) {
#			$fl =~ s/r$//;
#			$el =~ s/^([^sndtl]*?[sndtl])/$1\+/;
#		} else {
#			$el =~ s/^([^sndtl]*?[ndtl])/$1\+/;
#		}
#	} # end if
	
#print LOGG "\$fl = $fl at sub retr end\n" if $logg;
#print LOGG "\$el = $el at sub retr end\n" if $logg;
	return ($fl,$el);
} # end sub

sub no_retr_flag {
	my ($fl,$el) = @_;
#print LOGG "\$fl = $fl at sub no_retr_flag start\n" if $logg;
#print LOGG "\$el = $el at sub no_retr_flag start\n" if $logg;
	my $cmptemp = $fl."<SKARV>".$el;
	my $last_fl_syll = (split /\./,$fl)[-1];
	my $stress_on_last_syll = $last_fl_syll =~ s/\'/\'/g;
	my $r_after_short_vowel = $last_fl_syll =~ s/([^\:])r$/\$1r/g;
	my $no_retr_flag = 0;
	$no_retr_flag = 1 if ($stress_on_last_syll && $r_after_short_vowel);
#print LOGG "\$fl = $fl at sub no_retr_flag end\n" if $logg;
#print LOGG "\$el = $el at sub no_retr_flag end\n" if $logg;
	return $no_retr_flag;
}

#****************************************** VELARISERING ********************************************
sub velarisering {
	my ($fl,$el) = @_;
#print LOGG "\$fl = $fl at sub velarisering start\n" if $logg;
#print LOGG "\$el = $el at sub velarisering start\n" if $logg;
#	my $cmptemp = $fl."<SKARV>".$el;
#	$cmptemp =~ s/([^m])n(<SKARV>[\'\"\.2]*[gk])/$1nK$2/;
#	($fl,$el) = split "<SKARV>",$cmptemp;
#print LOGG "\$fl = $fl at sub velarisering end\n" if $logg;
#print LOGG "\$el = $el at sub velarisering end\n" if $logg;
	return ($fl,$el);
} # end sub

sub x_ify_lh {

	my $ttt = shift;

	$ttt =~ s/E\&U0/x151/g;	#OK	diftong au
	$ttt =~ s/E\+\&Y/x153/g;	#OK	diftong y
	$ttt =~ s/E\&I/x152/g;	#OK	diftong ei
	$ttt =~ s/n\+%\)/x930/g;	#	stavelsesbrende konsonant n+
	$ttt =~ s/l\+%\)/x940/g;	#	stavelsesbrende konsonant l+
	$ttt =~ s/A\&I/x154/g;	#OK	diftong ai
	$ttt =~ s/O\&I/x155/g;	#OK	diftong oi
	$ttt =~ s/t\&S/x190/g;	#	ustemt affrikat tsjekkia
	$ttt =~ s/n%\)/x910/g;	#	stavelsesbrende konsonant n
	$ttt =~ s/l%\)/x920/g;	#	stavelsesbrende konsonant l
	$ttt =~ s/u0:/x050/g;	#OK	lang vokal u
	$ttt =~ s/e\+:/x090/g;	#OK	lang vokal 
	$ttt =~ s/A:/x010/g;	#OK	lang vokal a
	$ttt =~ s/e:/x020/g;	#OK	lang vokal e
	$ttt =~ s/i:/x030/g;	#OK	lang vokal i
	$ttt =~ s/u:/x040/g;	#OK	lang vokal o
	$ttt =~ s/y:/x060/g;	#OK	lang vokal y
	$ttt =~ s/o:/x070/g;	#OK	lang vokal 
	$ttt =~ s/\@:/x081/g;	#OK	lang vokal 
	$ttt =~ s/U0/x221/g;	#OK	kort vokal u
	$ttt =~ s/E\+/x091/g;	#OK	kort vokal 
	$ttt =~ s/d\+/x100/g;	#OK	retrofleks d
	$ttt =~ s/t\+/x110/g;	#OK	retrofleks t
	$ttt =~ s/n\+/x130/g;	#OK	retrofleks nasal
	$ttt =~ s/l\+/x140/g;	#OK	retrofleks lateral
	$ttt =~ s/nK/x400/g;	#OK	velar nasal
	$ttt =~ s/r6/x421/g;	#OK	alveolar flap
	$ttt =~ s/2\'/x510/g;	#OK	tonem 2
	$ttt =~ s/\'2/x520/g;	#OK	bitrykk
	$ttt =~ s/A/x181/g;	#OK	kort vokal a
	$ttt =~ s/I/x200/g;	#OK	kort vokal i
	$ttt =~ s/U/x210/g;	#OK	kort vokal u
	$ttt =~ s/Y/x230/g;	#OK	kort vokal y
	$ttt =~ s/O/x240/g;	#OK	kort vokal 
	$ttt =~ s/E/x250/g;	#OK	kort vokal e
	$ttt =~ s/b/x270/g;	#OK	b
	$ttt =~ s/d/x280/g;	#OK	d
	$ttt =~ s/g/x290/g;	#OK	g
	$ttt =~ s/p/x300/g;	#OK	p
	$ttt =~ s/t/x310/g;	#OK	t
	$ttt =~ s/k/x320/g;	#OK	k
	$ttt =~ s/f/x330/g;	#OK	f
	$ttt =~ s/s/x340/g;	#OK	s
	$ttt =~ s/S/x341/g;	#OK	sj
	$ttt =~ s/V/x360/g;	#OK	v
	$ttt =~ s/C/x370/g;	#OK	kj
	$ttt =~ s/m/x380/g;	#OK	m
	$ttt =~ s/n/x390/g;	#OK	n
	$ttt =~ s/l/x410/g;	#OK	l
	$ttt =~ s/h/x430/g;	#OK	h
	$ttt =~ s/j/x440/g;	#OK	j
	$ttt =~ s/\'/x500/g;	#OK	hovedtrykk
	$ttt =~ s/\./x530/g;	#OK	stavelsesgrense
	$ttt =~ s/\_/x550/g;	#OK	underscore
	$ttt =~ s/\"/x570/g;	#OK	fraseaksent

	return $ttt;

} # end sub

sub syllabify {
	my $ilstring = shift;
	my $voc_pattern = "(x010|x020|x030|x040|x050|x060|x070|x081|x090|x091|x151|x152|x153|x154|x155|x181|x200|x210|x221|x230|x240|x250|x910|x920|x930|x940)";
	my $stress_pattern = "(x500|x510|x520|x570|)";
	my $syll_pattern = "x530";
	my $onset_pattern = join "|",@il_onsets;
	$onset_pattern =~ s/^(.*)$/\($1|\)/;
	my $ret = "";
	while ($ilstring =~ s/^((.*?)($stress_pattern)($onset_pattern)($voc_pattern))//) {
		$ret .= "$2$syll_pattern$3$5$7";
	}
	$ret .= $ilstring;
	$ret =~ s/^$syll_pattern//;
	$ret = fix_corrupt_syll($ret);
	return $ret;
} # end sub

# Fix that takes care of unusual initial clusters such as ts, ps and so on that are not legal onsets but exists
# appends syllables with no vowel with the syllable that follows 
sub fix_corrupt_syll {
	my $ret = shift;
	my $newret = "";
	my @newsylls = ();
	my $deletetag = "TABORT";
	my @sylls = split /x530/,$ret;
	my $voc_pattern = "(x010|x020|x030|x040|x050|x060|x070|x081|x090|x091|x151|x152|x153|x154|x155|x181|x200|x210|x221|x230|x240|x250|x910|x920|x930|x940)";
	foreach $s (@sylls) {
		unless ($s =~ /$voc_pattern/) {
			$s = $s.$deletetag;
		} # end unless
		push @newsylls,$s;
	}
	$newret = join "x530",@newsylls;
	$newret =~ s/TABORTx530//g;
	return $newret;
} # end sub
