#!perl -w

###################################################################################################
#	recomp_digits.pl
#	Skaper transkripsjoner av tallord.
#	Skilletegn: _ mellom ord, + mellom sammensettingsledd  (fem_hundre_og_tjue+tre)
#	220501: GA
###################################################################################################

#SET FORMAT
$onesfirst = 0;

#******************************************* UTFIL ************************************************
open OUT,">recomp_digits.OUT";
#******************************************* LEKSIKON *********************************************
open LEX, "diglex.txt";
while (<LEX>) {
	chomp;
	@lexline = split /\t/, $_;
	$lexort = $lexline[0];
	$lextrk = $lexline[1];
	$lex{$lexort} = $lextrk;	
}
#********************************************* INNFIL *********************************************
open IN,"tall.txt";
#********************************************* HOVEDSNURR *****************************************
while (<IN>) {
	@fulltrks = "";
	chomp;
	($dig,$fullort) = split /\t/, $_;
	@words = split /_/, $fullort;
	foreach $word (@words) {		
		@trks = "";
		@dec = split /\+/,$word;
		$el = pop @dec;
		$el_trk = &lookup($el);
		$el_trk =~ s/(\")+/\%/ if ($onesfirst && ($word =~ /\+/));
		foreach $fl (@dec) {
			$fl_trk = &lookup($fl);
			$fl_trk =~ s/(\")+/\%/ unless $onesfirst;
			push @trks,$fl_trk;
		}
		push @trks,$el_trk;
		$trks = join "\$",@trks;
		$trks =~ s/^\$//;
		push @fulltrks,$trks;
	}
	if ($fullort =~ /_/) {
		if (($fullort =~ /og_([a-z])+((\+)([a-z])+)?$/) or ($fullort =~ /([a-z])+\+og\+([a-z])+$/)) {
		$fulltrks[-1] =~ s/((\")+)/$1/;	#fraseaksent havner p siste ledd 145=ett hundre og frti FEM
		}
		else {$fulltrks[-2] =~ s/((\")+)/$1/}	#fraseaksent havner p nest siste ledd 100=ETT hundre
	}
	$fulltrk = join "\_", @fulltrks;
	$fulltrk =~ s/^_//;
	print OUT "$dig\t$fullort\t$fulltrk\n"; 
}
#******************************************** LOOKUP ***********************************************
sub lookup {
	my $el = shift;
	my $lexstuff;
	if (exists ($lex{$el})) {
		$lexstuff = $lex{$el};
	} else {
		$lexstuff = "####";
	}
	return $lexstuff;
} #end sub
