#!perl -w

my $sw_kons = "[bcdfghjklmnpqrstvwxz]";

my @sw_ok2el = qw(
EM
LP
OS
SM
TV
VM
al
as
av
ax
be
bi
bo
by
cd
di
dy
d
ed
ek
el
em
en
ex
f
g
ho
hy
il
in
is
ko
k
le
lo
l
mo
m
ny
om
os
p
ro
r
r
sa
se
sm
so
sy
s
ta
te
tu
tv
ty
t
t
ur
ut
uv
vm
vy
yl
yr
k
l
n
r
s
t
k
l
m
n
s
);

my $sw_ok2el = join "|",@sw_ok2el;
#$sw_ok2el = "(".$sw_ok2el.")";

my @sw_ok3el = qw(
man
tid
lag
hus
vik
ls
rum
dag
bok
tal
fri
vg
ns
liv
ml
rik
bil
mn
hem
rd
bt
bom
byn
del
ord
dal
val
bro
tg
ort
led
sj
kp
sal
fel
vis
rr
ss
ln
ben
typ
hg
art
mat
nt
duk
vin
bud
vg
syn
rd
kr
sex
tur
ren
yta
tv
bit
tag
sko
bad
hl
ln
ton
tak
rot
tyg
fot
lek
sak
par
gas
hot
ga
ros
fat
lv
bas
ost
vit
het
bl
ved
ram
gul
ls
rop
vn
kr
br
dd
akt
kk
tar
hr
sg
zon
mur
lov
tr
ugn
eld
dom
vv
tro
bod
ryd
lt
gr
sr
rt
gs
mor
ris
fru
ras
far
hud
tog
kur
rk
kar
arm
nl
lin
hav
mus
fil
sax
fr
box
ke
ull
gr
lk
gr
hed
gud
rem
sl
don
yxa
lut
ger
sol
kn
bur
rus
dd
gd
kor
fin
lav
nt
orm
ng
ask
gav
pil
mod
kr
dra
sur
Ove
gg
dam
gd
van
ges
haj
god
apa
myr
kl
mos
rv
vid
bor
rm
bal
st
bn
ser
kom
kod
ber
rim
tt
fr
id
len
ler
ln
sm
kam
med
lax
bon
hal
sim
gk
bin
arv
dos
bra
bys
gl
Ola
hov
deg
kol
tom
fyr
sl
dis
paj
ga
lus
vas
lim
lr
sot
min
rn
ess
men
ka
ses
bak
mil
hop
bot
oxe
vax
tam
not
sd
tub
st
sp
fly
yra
bl
nd
has
kap
cup
toa
hv
mes
rep
Uno
sed
ra
red
klo
pop
sn
lok
mot
tr
rar
rom
ta
rud
som
st
vag
ark
rt
de
tik
kil
vt
sky
nr
dan
rev
fet
vr
uti
set
aga
sug
lya
tt
alg
lur
ner
opp
gt
sin
rn
Maj
vig
re
mun
kok
ine
kli
fan
bog
boj
Owe
rov
ra
gap
dop
upp
sus
dun
ke
hk
rak
eko
lob
kaj
mal
mn
sa
ila
mon
va
mix
log
hr
ra
vl
nos
lat
mn
ont
alm
tr
vr
Ann
pl
buk
rr
rt
hit
lod
huv
kex
ide
rn
pik
bs
dv
ung
sup
hr
vak
nav
gt
koj
oro
lv
fl
rit
May
kul
maj
jet
bus
kon
ond
por
fen
kn
sl
kl
lg
sto
kub
ute
egg
boa
bag
tum
kt
syr
teg
tr
hn
fog
arg
ts
bov
pir
myt
dok
res
ss
hej
gam
gom
sg
rea
ka
rs
kk
off
br
rg
sv
vek
hon
fax
udd
nog
sm
bli
nyp
dur
hak
bj
bet
ror
sk
kal
ms
da
avi
dar
lys
agg
nd
kik
tun
eka
ar
fis
Mai
pub
gem
tm
jul
da
dyr
dn
isa
fur
dyn
Ole
moj
lir
sej
sr
pg
ned
lom
sys
Gun
fn
fs
ron
vel
bry
sik
lyx
spy
kyl
rk
hl
gro
duo
hg
ns
byk
riv
nr
kit
ana
lem
Ahl
Len
ls
mej
sl
kk
alt
sly
dk
bug
tn
goa
jon
boy
fl
out
jv
gno
roa
tok
hel
fik
Bro
Ulf
gal
ns
sov
Mia
la
ls
kt
arr
Ata
nya
dog
lab
gig
sp
lam
sn
sas
rt
hip
Mor
end
Lee
dum
hor
hos
Lie
glo
mt
pk
dyk
Ray
bla
lg
rr
ork
Pia
hn
hyr
sp
Eve
Jan
oas
ini
pos
fix
sop
tia
bre
);
my $sw_ok3el = join "|",@sw_ok3el;


sub postfix {
	my $dec = shift;
	$dec = fix_dec_fl($dec);
	$dec = fix_dec_el($dec);
	$dec = fix_fl_1_char($dec);
#	$dec = fix_fl_2_char($dec);
#	$dec = fix_fl_2_char($dec);
	
	
	return $dec;
}


sub fix_dec_el {
	my $dec = shift;
#	print "$dec\-\-\>";

	# fix one-letter el. Only accept 'i' and ''. Remove leading boundarie mark(s) in other cases
	$dec =~ s/\++([^])$/$1/;
#	print "$dec\n$dec-\-\>";
	
	# fix two-letter el. First, do not accept consonant sequences. (This is no longer nescessary...)
	$dec =~ s/\++($sw_kons+)$/$1/;
#	print "$dec\n$dec-\-\>";

	# Only accept listed 2-letter endings from @sw_ok2el
	$dec =~ s/\++(..)$/$1/ if $dec !~ /\+($sw_ok2el)$/;
#	print "$dec\n$dec-\-\>";
	
	# fix three-letter el. Only accept listed 3-letter endings from @sw_ok3el
	$dec =~ s/\++(...)$/$1/ if $dec !~ /\+($sw_ok3el)$/;
#	print "$dec\n";
	

	return $dec;
	
}

sub fix_dec_fl {
	my $dec = shift;
	

	# +ko+
	$dec =~ s/(kyr|anar)\+(ko\+)/$1$2/g;
	$dec =~ s/(\+s)\+(ko\+)/$1$2/g;
	$dec =~ s/(\+ko)\+/$1/g;
	# +re+
	$dec =~ s/(msta|hav|her|stav|gen|rtta)\+(re\+)/$1$2/g;
	$dec =~ s/(\+re)\+/$1/g;
	# +f+ m.fl
	$dec =~ s/\+f\+/f/g;
	$dec =~ s/\+el\+/el\+/g;
	# +ar+
	$dec =~ s/(\+ar)\+(bet|ving|gume|ve|vode|mad)/$1$2/g;
	$dec =~ s/\+ar\+/ar\+/g;
	
#	$dec =~ s/\+[aue]\+//g;
	
	# 'fix' linking s. Many will still be appended incorrectly. Snyft...
	$dec =~ s/(s\+s)\+([^s])/$1$2/g;
	$dec =~ s/([^s])\+(s\+s)/$1$2/g;
	$dec =~ s/\+s\+/s\+/g;
	
	$dec =~ s/\+ta\+/ta\+/g;
	
	
	
	# +ad+ and fl ad+
	$dec =~ s/\+ad\+/\+ad/g;
	$dec =~ s/^ad\+/ad/g;
	
	
	return $dec;
}

sub fix_fl_1_char {
	my $dec = shift;
	# 1-letter fl. Only accept i o 
	$dec =~ s/^([^io])\+/$1/g;
	return $dec;
}

sub fix_fl_2_char {
	my $dec = shift;
	# 1-letter fl. Only accept i o 
	$dec =~ s/^([^io])\+/$1/g;
	return $dec;
}
